Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

MAXTRACK EQU       180                      ; maximln poet stop
MAXSEKT  EQU       48                       ; maximln poet sektor na stopu
MAXSIDE  EQU       2                        ; maximln poet stran
; Pozor, aby buffer pro 1 stopu (MAXSEKT*512) nedoshl 32 KB !

bit0     EQU       1
bit1     EQU       2
bit2     EQU       4
bit3     EQU       8
bit4     EQU       10h
bit5     EQU       20h
bit6     EQU       40h
bit7     EQU       80h

; ------ inicializace programu

Start:   cmp       byte ptr ds:[80h],0
         je        Start1
         call      TempInit                 ; inicializace pechodnho souboru
Start1:  call      Inst1E                   ; instalace 1Eh
         call      DIns1E                   ; odinstalovn 1Eh

; ------ rozbor pkazovho dku

         call      Rozbor                   ; rozbor pkazovho dku
         pushf
         push      si
         mov       si,offset UvTxt          ; vodn text
         call      StdOutT                  ; zobrazen vodnho textu
         pop       si
         popf
         jnc       Start2                   ; parametry zadny OK

; ------ chyba - zobrazen npovdy

         mov       si,offset Help2Txt
         call      RepOut
         mov       si,offset HelpTxt        ; text npovdy
         jmp       short Chyba1

Prerus:  call      MazText
         mov       si,offset PrerTxt
         call      RepOut
         jmp       short INT23

Chyba:   call      MazText                  ; vymazn textu
         call      RepOut
Chyba1:  call      StdOut                   ; zobrazen chybovho textu

INT23:   call      DIns1E                   ; odinstalovn INT 1Eh
         call      TempClos                 ; uzaven pechodnho souboru
         mov       ax,4c01h
         int       21h

; ------ pedefinovn zsobnku

Start2:  mov       si,offset MemTxt         ; text - chyba pamti
         cmp       sp,offset Zasobnik       ; kontrola konce zsobnku
         jb        Chyba                    ; chyba pamti
         mov       sp,offset Zasobnik       ; pedefinovn ukazatele zsobnku

; ------ zmenen bloku programu

         push      cs
         pop       es                       ; ES <- segment PSP
         mov       bx,(offset(Zasobnik-Start)+10fh)/16
         mov       ah,4ah
         int       21h                      ; zmenen bloku programu
         jc        Chyba                    ; njak chyba

; ------ vytvoen datovho bloku

         mov       bx,-1
         mov       ah,48h
         int       21h                      ; dotaz na maximln velikost bloku
         mov       ah,48h
         int       21h                      ; pidlen maximlnho bloku
         jc        Chyba                    ; njak chyba

; ------ kontrola velikosti datovho bloku

         cmp       bx,4*(MAXSEKT*512/16)+ 4*512/16 ; minimln velikost bufferu
         jb        Chyba                    ; mlo pamti
         mov       ds:[BuffBeg],ax          ; adresa bufferu
         add       bx,ax                    ; adresa konce bufferu

; ------ stanoven adresy bufferu pracovn stopy

         mov       ds:[BuffDisk],ax         ; mon adresa bufferu
         and       ah,0fh                   ; offset v segmentu 64 KB
         add       ax,MAXSEKT*512/16        ; zven adresy bufferu
         test      ah,0f0h                  ; je peteen 64 KB ?
         jz        Start22                  ; nen peteen 64 KB
         add       word ptr ds:[BuffDisk],MAXSEKT*512/16 ; jin adresa bufferu

; ------ stanoven adresy bufferu verifikovan stopy

Start22: mov       ax,ds:[BuffDisk]         ; adresa bufferu pracovn stopy
         add       ax,MAXSEKT*512/16        ; adresa bufferu verifikovan stopy
         mov       ds:[BuffDskV],ax         ; mon adresa bufferu
         and       ah,0fh                   ; offset v segmentu 64 KB
         add       ax,MAXSEKT*512/16        ; zven adresy bufferu
         test      ah,0f0h                  ; je peteen 64 KB ?
         jz        Start24                  ; nen peteen 64 KB
         add       word ptr ds:[BuffDskV],MAXSEKT*512/16 ; jin adresa bufferu

; ------ adresa datovho bufferu

Start24: mov       ax,ds:[BuffDskV]         ; adresa diskovho bufferu
         add       ax,MAXSEKT*512/16        ; adresa datovho bufferu
         mov       ds:[BuffDat],ax          ; adresa datovho bufferu

; ------ maximln poet sektor v bufferu

         sub       bx,ax                    ; velikost zbytku bufferu
         mov       cl,5                     ; poet rotac
         shr       bx,cl                    ; poet sektor
         mov       ds:[BuffMax],bx          ; maximln poet sektor v bufferu

; ------ pedefinovn obsluhy INT 23h

         mov       dx,offset INT23
         mov       ax,2523h
         int       21h                      ; definice adresy INT 23h

; ------ nulovn tabulky chyb

         call      ResDisk                  ; resetovn diskovho systmu
         push      ds
         pop       es                       ; ES <- datov segment
         mov       di,offset ErrMap
         mov       cx,offset(ErrMap0-ErrMap)
         xor       ax,ax
         cld
         rep       stosb                    ; vymazn tabulky

; ------ funkce vygenerovn paritn diskety

         test      byte ptr ds:[Operace],bit0 ; je generovn diskety ?
         jz        Start3                   ; nen generovn diskety
         call      Gener                    ; generovn paritn diskety
         jmp       short Start9

; ------ funkce obnoven pokozen diskety

Start3:  test      byte ptr ds:[Operace],bit1 ; je obnoven pokozen diskety ?
         jz        Start4
         call      Obnov                    ; obnoven vadn diskety
         jmp       short Start9

; ------ funkce testu vech disket archivu

Start4:  test      byte ptr ds:[Operace],bit2 ; je test vech disket ?
         jz        Start5
         call      TestV                    ; test vech disket archivu
         jmp       short Start9

; ------ funkce testu jedn diskety archivu

Start5:  test      byte ptr ds:[Operace],bit3 ; je test jedn diskety ?
         jz        Start6
         call      Test1                    ; test jedn diskety
         jmp       short Start9

; ------ funkce modifikace paritn diskety

Start6:  test      byte ptr ds:[Operace],bit4 ; je modifikace paritn diskety ?
         jz        Start7
         call      Modif                    ; modifikace diskety
         jmp       short Start9

; ------ funkce identifikanho kdu diskety

Start7:  test      byte ptr ds:[Operace],bit5 ; idnentifikan kd diskety ?
         jz        Start8
         call      Ident                    ; idnetifikan kd diskety
;         jmp       short Start9

Start8:

; ------ dn konec programu

Start9:  call      DIns1E                   ; odinstalovn INT 1Eh
         call      TempClos                 ; uzaven pechodnho souboru
         mov       ax,4c00h
         int       21h

; *****************************************************************************
;
;                     Funkce generovn paritn diskety
;
; *****************************************************************************
;
Gener    PROC      NEAR

; ------ zobrazen npovdy

         mov       si,offset GenTxt
         call      StdOutT                  ; zobrazen vzvy k vloen diskety

; ------ potvrzen operace

Gener1:  mov       si,offset GenTxt1
         mov       di,offset GenMnu1
         call      Menu                     ; volba dal operace
         cmp       al,"D"
         je        Gener2
         call      XchgDsk                  ; vmna disku
         jnc       Gener1
Gener12: jmp       Prerus

; ------ pihlen diskety

Gener2:  call      TempOpen                 ; vytvoen pechodnho souboru
         test      byte ptr ds:[Operace],bit1+bit4 ; je paritn disketa ?
         jz        Gener22
         or        byte ptr ds:[Param],bit2 ; uren paritn disketa
Gener22: call      ReadBoot                 ; inicializace diskety
         jc        Gener1                   ; opakovn operace
         call      InitDisk                 ; inicializace diskovch parametr

; ------ prvn disketa je paritn, je-li modifikace nebo obnoven

         test      byte ptr ds:[Operace],bit1+bit4 ; je to paritn disketa ?
         jz        Gener3                   ; nen
         or        byte ptr ds:[Param],bit4+bit2 ; je paritn disketa
         call      VolParit                 ; nvt pro paritn disketu

; ------ naten diskety s operac XOR

Gener3:  call      CtiDisk                  ; naten diskety s XOR
         jnc       Gener32                  ; nen peruen
         test      byte ptr ds:[Param],bit2 ; je paritn disketa ?
         jnz       Gener1                   ; je paritn disketa
Gener32: and       byte ptr ds:[Param],not bit2 ; nen uren paritn disketa

; ------ vzva k vloen dal diskety

Gener4:  mov       si,offset GenTxt2
         mov       di,offset GenMnu2
         call      Menu                     ; volba dal operace
         call      XchgDsk                  ; vmna diskety
         jnc       Gener4
         cmp       al,"Z"
         je        Gener6                   ; konec
         cmp       al,"D"
         jne       Gener12

; ------ dal disketa - test shodnosti parametr diskety

Gener5:  call      ReadBoot
         jc        Gener4                   ; peruen operace
         call      CompDisk                 ; porovnn parametr disku
         jnc       Gener3                   ; naten dal diskety

; ------ disketa nen shodn

         mov       si,offset FrmSTxt
         mov       di,offset FrmSTxtM
         call      Menu
         jc        Gener4                   ; peruen
         cmp       al,"O"
         je        Gener5                   ; opakovn
         jmp       short Gener4             ; peruen
;         cmp       al,"N"
;         je        Gener4                   ; nvrat
;Gener14: jmp       short Gener12            ; peruen

; ------ test, zda byla chyba dat pi obnoven

Gener6:  test      byte ptr ds:[Operace],bit1 ; je obnoven diskety ?
         jz        Gener609                 ; nen obnoven diskety
         push      ds
         pop       es
         mov       di,offset ErrMap         ; mapa chyb
         mov       cx,offset ErrMap0-ErrMap ; velikost mapy
         xor       ax,ax
         cld
         repe      scasb                    ; test, zda byla chyba
         je        Gener609                 ; nebyla dn chyba

; ------ vzva k vloen opravovan diskety

         mov       si,offset OprvTxt
         mov       di,offset OprvMnu
         call      Menu                     ; obsluha menu
         cmp       al,"Z"
         je        Gener609                 ; zpis
         cmp       al,"D"
         jne       Gener4                   ; nen dle - peruen
         call      ObnvOld                  ; obnoven z pvodn diskety

; ------ jsou ji vechny diskety - vzva k vloen przdn diskety

Gener609:mov       si,offset VystTxt
         mov       di,offset VystMnu
         test      byte ptr ds:[Operace],bit1 ; je obnoven diskety ?
         jnz       Gener60                  ; je obnoven diskety
         mov       si,offset PartTxt
         mov       di,offset PartMnu
Gener60: call      Menu                     ; volba
         jc        Gener622                 ; nvrat menu
         call      XchgDsk                  ; vmna diskety
         jnc       Gener609
         cmp       al,"N"
         je        Gener622                 ; nvrat menu
         cmp       al,"Z"
         jne       Gener622                 ; nen zpis - je peruen

; ------ inicializace paritn diskety

Gener61: test      byte ptr ds:[Operace],bit1 ; je obnoven diskety ?
         jnz       Gener611                 ; je obnoven diskety
         test      byte ptr ds:[Param],bit0 ; je paritn disketa v souboru ?
         jz        Gener611                 ; nen disketa v souboru
         or        byte ptr ds:[Param],bit4 ; je paritn disketa
         call      VolParit
         call      ZapOutp                  ; zpis vstupnho souboru
         jmp       short Gener66

Gener611:call      ReadBoot                 ; naten BOOT sektoru
         call      CompDisk                 ; porovnn parametr disku
         jnc       Gener62                  ; naten dal diskety

; ------ disketa nen shodn

         mov       si,offset FrmSTxt
         mov       di,offset FrmSTxtM
         call      Menu
         jc        Gener622                 ; peruen
         cmp       al,"O"
         je        Gener61                  ; opakovn
;         cmp       al,"N"
;         jne       Gener144                 ; peruen
Gener622:jmp       Gener4                   ; nvrat

; ------ korekce jmenovky

Gener62: test      byte ptr ds:[Operace],bit1 ; je obnoven diskety ?
         jnz       Gener63                  ; je obnoven diskety
         or        byte ptr ds:[Param],bit4 ; je paritn disketa
         call      VolParit                 ; nvt pro paritn disketu
         jmp       short Gener64

Gener63: call      VolObnov                 ; korekce jmenovky pi obnoven

; ------ zpis diskety

Gener64: call      ZapDisk                  ; zpis paritn diskety
         call      TstBreak                 ; test peruen
         jc        Gener622

; ------ hlen o zpisu diskety

Gener66: test      byte ptr ds:[Operace],bit1 ; je obnoven ?
         jnz       Gener7                   ; je obnoven - nen hlen
         test      byte ptr ds:[Param],bit0 ; paritn disketa v souboru ?
         jnz       Gener7
         mov       si,offset ParitTxt
         call      StdOutT                  ; zobrazen hlen
Gener7:  ret

Gener    ENDP

; -----------------------------------------------------------------------------
;        jmenovka pro paritn disketu
; -----------------------------------------------------------------------------

VolParit PROC      NEAR

         test      byte ptr ds:[Param],bit4 ; je paritn disketa ?
         jz        VolPari9                 ; nen paritn disketa

         push      bx
         push      es

         push      ds
         pop       es                       ; ES <- datov segment
         mov       bx,offset ParTxt
         call      CopyLab                  ; kopie jmenovky do buffer

         pop       es
         pop       bx

VolPari9:ret

VolParit ENDP

; *****************************************************************************
;
;                       Funkce obnoven vadn diskety
;
; *****************************************************************************
;
Obnov    PROC      NEAR

; ------ zobrazen vodn vzvy

         mov       si,offset ObnTxt
         call      StdOutT                  ; zobrazen vzvy k vloen diskety

         test      byte ptr ds:[Param],bit0 ; je paritn disketa ?
         jz        Obnov1                   ; nen
         call      TempOpen                 ; vytvoen pechodnho souboru
         cmp       word ptr ds:[OutpIdnt],0 ; je oteven soubor ?
         jne       Obnov2                   ; soubor je oteven OK

; ------ potvrzen operace

Obnov1:  mov       si,offset ObnTxt1
         mov       di,offset ObnMnu1
         call      Menu                     ; volba dal operace
         cmp       al,"D"
         je        Obnov2
         call      XchgDsk                  ; vmna disku
         jnc       Obnov1
Obnov12: jmp       Prerus

Obnov2:  jmp       Gener2

Obnov    ENDP

; -----------------------------------------------------------------------------
;        korekce jmenovky pi obnoven (neuchovv registry)
; -----------------------------------------------------------------------------

VolObnov PROC      NEAR

; ------ inicializan vymazn jmenovky

         push      ds
         pop       es                       ; ES <- datov segment
         mov       bx,offset MazTTxt1       ; sam mezery
         call      CopyLab                  ; kopie do buffer

; ------ inicializace jmenovky disku

         mov       es,ds:[BuffDat]          ; zatek datovho bufferu
         test      byte ptr ds:[Param],bit3 ; je nekompatibiln BOOT ?
         jnz       VolObn3                  ; nekompatibiln BOOT
         cmp       byte ptr es:[10h],2      ; je poloka tabulek FAT ?
         jb        VolObn3                  ; neplatn BOOT
         cmp       byte ptr es:[bx+26h-2bh],29h ; je to rozen sektor ?
         jne       VolObn4
         mov       bx,2bh                   ; jmenovka pro DOS 4
VolObn1: call      TestLab                  ; test jmenovky diskety ES:BX
         jc        VolObn3                  ; jmenovka neplat, asi paritn disk

; ------ jmenovka NO NAME je neplatn

         mov       di,bx                    ; offset adresy jmenovky
         mov       si,offset NoNamTxt       ; jmenovka "NO NAME"
         mov       cx,11
         cld
         repe      cmpsb                    ; je to jmenovka NO NAME ?
         je        VolObn3                  ; je jmenovka NO NAME
         call      CopyLab                  ; kopie jmenovky disku ES:BX
VolObn3: ret

; ------ zjitn potu sektor ROOT

VolObn4: mov       bp,es:[11h]              ; poet poloek ROOT
         shr       bp,1
         shr       bp,1
         shr       bp,1
         shr       bp,1                     ; poet sektor ROOT
         jz        VolObn3                  ; nen platn ROOT

; ------ zjitn potenho sektoru ROOT

         mov       ax,es:[16h]              ; poet sektor jedn tabulky FAT
         shl       ax,1                     ; poet sektor na ob tabulky FAT
         jc        VolObn3                  ; chyba
         add       ax,es:[0eh]              ; piten rezervovanch sektor
         jc        VolObn3
         xchg      ax,di                    ; DI <- slo potenho sektoru

; ------ vpoet adresy potku ROOT

         mov       ax,512/16                ; poet odstavc na sektor
         mul       di                       ; offset
         add       ax,ds:[BuffDat]          ; adresa sektoru
         xchg      ax,dx                    ; DX <- adresa sektoru

; ------ test, zda je platn sektor

VolObn5: cmp       di,ds:[BuffMax]          ; je to platn sektor ?
         jae       VolObn3                  ; nen to platn sektor

; ------ prohledn jednoho sektoru

         mov       es,dx                    ; adresa sektoru
         xor       bx,bx                    ; offset
         mov       cx,16                    ; poet poloek na sektor
VolObn6: cmp       byte ptr es:[bx],0
         je        VolObn3                  ; konec adrese
         cmp       byte ptr es:[bx],0e5h
         je        VolObn7                  ; zruen poloka
         test      byte ptr es:[bx+0bh],bit3 ; je to nvt disku ?
         jnz       VolObn1                  ; nvt disku nalezeno OK
VolObn7: add       bx,32                    ; adresa dal poloky
         loop      VolObn6                  ; test dal poloky

; ------ zven adresy

         inc       di                       ; zven sla sektoru
         add       dx,512/16                ; zven adresy v pamti
         jmp       short VolObn5

VolObnov ENDP

; -----------------------------------------------------------------------------
;        obnoven dat z pvodn vadn diskety (neuchovv registry !)
; -----------------------------------------------------------------------------

ObnvOld  PROC      NEAR

         or        byte ptr ds:[Param],bit1  ; je obnovovan disketa

; ------ pihlen diskety

ObnvOld1:call      ReadBoot
         call      CompDisk                 ; porovnn parametr disku
         jnc       ObnvOl14                 ; disketa je OK

; ------ disketa nen shodn (neuchovvat nic v zsobnku - vrac se !)

         mov       si,offset FrmSTxt
         mov       di,offset FrmSTxtM
         call      Menu
         cmp       al,"O"
         je        ObnvOld1                 ; opakovn
         cmp       al,"P"
         je        ObnvOl12

         and       byte ptr ds:[Param],not bit1
         pop       ax                       ; zruen nvratov adresy
         jmp       Gener4                   ; nvrat

ObnvOl12:jmp       Prerus                   ; peruen

; ------ pprava k operaci naten disku

ObnvOl14:call      Inst1E                   ; instalace INT 1Eh

         mov       bp,offset ErrMap         ; mapa vadnch sektor

         mov       cl,1                     ; maska v map
         mov       ch,0                     ; ukazatel sla vlce
ObnvOld2:mov       dh,0                     ; ukazatel sla strany

; ------ naten jedn stopy

ObnvOld3:call      ReadTrck                 ; naten stopy

; ------ identifikan kd diskety

         mov       al,ch
         or        al,dh                    ; je stopa 0/strana 0 ?
         jnz       ObnvOld4                 ; nen stopa 0/strana 0
         call      SumEDCI                  ; identifikan kd

; ------ pprava k modifikaci sektor

ObnvOld4:mov       al,ds:[NumSekt]          ; poet sektor ve stop
         xor       si,si
ObnvOld5:test      byte ptr ds:[bp],cl      ; je sektor vadn ?
         jz        ObnvOld6                 ; sektor nen vadn

; ------ obnoven sektoru

         push      si
         push      cx
         push      ds

         xor       di,di
         mov       es,ds:[BuffUkaz]         ; ukazatel adresy
         mov       ds,ds:[BuffDisk]         ; segment naten stopy
         mov       cx,512/2                 ; poet slov
         cld
         rep       movsw                    ; penos sektoru

         pop       ds
         pop       cx
         pop       si

; ------ pprava pro dal sektor

ObnvOld6:shl       cl,1                     ; posun masky v map
         jnc       ObnvOld7
         inc       bp                       ; zven ukazatele v map
         mov       cl,1

ObnvOld7:add       si,512
         add       word ptr ds:[BuffUkaz],512/16 ; zven ukazatele v bufferu
         dec       word ptr ds:[BuffCit]    ; snen tae zbylch sektor
         jnz       ObnvOld9                 ; jsou dal sektory
         call      TempWrit                 ; zpis dat do souboru
         call      TempRead                 ; naten dalho bloku dat
ObnvOld9:dec       al                       ; ta sektor
         jnz       ObnvOld5                 ; dal sektor

; ------ zven ukazatele sla strany

         inc       dh                       ; zven sla strany
         cmp       dh,ds:[NumStran]
         jb        ObnvOld3                 ; ten dal strany

; ------ zven ukazatele sla stopy

         inc       ch                       ; zven sla stopy
         cmp       ch,ds:[NumStop]
         jb        ObnvOld2                 ; ten dal stopy

; ------ uloen souboru

         call      TempWrit                 ; zpis dat do souboru
         call      MazText
         call      DIns1E
         and       byte ptr ds:[Param],not bit1
         ret

ObnvOld  ENDP

; -----------------------------------------------------------------------------
;        test, zda je sektor CH/DH/CL v map chyb (CY=je vadn)
; -----------------------------------------------------------------------------

TestErrM PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si

; ------ vpoet absolutnho sektoru

         mov       al,ch                    ; slo vlce
         mul       byte ptr ds:[NumStran]   ; pepoet na absolutn stopu
         add       al,dh                    ; piten strany
         mov       dh,0
         adc       ah,dh
         mov       dl,ds:[NumSekt]          ; poet sektor na stopu
         mul       dx                       ; pepoet na sektory
         dec       cx                       ; korekce sla sektoru
         add       al,cl                    ; piten sla sektoru
         adc       ah,0

; ------ test sektoru v map

         mov       cl,al                    ; slo abs. sektoru
         and       cl,7                     ; offset v bajtu
         mov       ch,1                     ; maska
         shl       ch,cl                    ; rotace masky na pozici
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; offset bajtu
         xchg      ax,si
         test      ds:[si+ErrMap],ch        ; test bitu
         jz        TestErM2                 ; nen chyba
         stc                                ; pznak chyb

; ------ nvrat registr

TestErM2:pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

TestErrM ENDP

; *****************************************************************************
;
;                       Funkce modifikace paritn diskety
;
; *****************************************************************************
;
Modif    PROC      NEAR

; ------ zobrazen npovdy

         mov       si,offset ModTxt
         call      StdOutT                  ; zobrazen vzvy k vloen diskety

         test      byte ptr ds:[Param],bit0 ; je paritn disketa ?
         jz        Modif1                   ; nen
         call      TempOpen                 ; vytvoen pechodnho souboru
         cmp       word ptr ds:[OutpIdnt],0 ; je oteven soubor ?
         jne       Modif2                   ; soubor je oteven OK

; ------ potvrzen operace

Modif1:  mov       si,offset ObnTxt1
         mov       di,offset ObnMnu1
         call      Menu                     ; volba dal operace
         cmp       al,"D"
         je        Modif2
         call      XchgDsk                  ; vmna disku
         jnc       Modif1
Modif12: jmp       Prerus
Modif2:  jmp       Gener2

Modif    ENDP

; *****************************************************************************
;
;                     Funkce testu vech disket archivu
;
; *****************************************************************************
;
TestV    PROC      NEAR

; ------ zobrazen npovdy

         mov       si,offset TstVTxt
         call      StdOutT                  ; zobrazen vzvy k vloen diskety

         test      byte ptr ds:[Param],bit0 ; je paritn disketa ?
         jz        TestV1                   ; nen
         call      TempOpen                 ; vytvoen pechodnho souboru
         cmp       word ptr ds:[OutpIdnt],0 ; je oteven soubor ?
         jne       TestV23                  ; soubor je oteven OK

; ------ potvrzen operace

TestV1:  mov       si,offset ObnTxt1
         mov       di,offset ObnMnu1
         call      Menu
         call      XchgDsk
         jnc       TestV1
         cmp       al,"D"
         je        TestV22
TestV2:  jmp       Prerus                   ; konec

; ------ pihlen diskety

TestV22: call      TempOpen                 ; vytvoen pechodnho souboru
TestV23: or        byte ptr ds:[Param],bit2
         call      ReadBoot                 ; inicializace diskety
         jc        TestV1                   ; peruen
         call      InitDisk                 ; inicializace diskovch parametr
         or        byte ptr ds:[Param],bit4+bit2 ; je paritn disketa
         call      VolParit                 ; nvt pro paritn disketu

; ------ naten diskety s operac XOR

TestV3:  mov       word ptr ds:[UspechS],0  ; spnost obnoven sektor
         call      CtiDisk                  ; naten diskety
         jnc       TestV31                  ; nen peruen
         test      byte ptr ds:[Param],bit2 ; je paritn disketa ?
         jnz       TestV1                   ; je paritn disketa
         jmp       short TestV4             ; dal disketa
TestV31: and       byte ptr ds:[Param],not bit2 ; nen uren paritn disketa

; ------ dekdovn sla spnosti

         xor       ax,ax
         cmp       word ptr ds:[NDisket],1
         jbe       TestV32
         mov       ax,ds:[UspechS]          ; poet sp؟nch sektor
         mov       cx,100
         mul       cx                       ; poet sektor * 2
         div       word ptr ds:[CelkSkt0]   ; spnost
TestV32: push      ds
         pop       es
         mov       di,offset DiskUsp+2
         mov       word ptr ds:[di-2],"  "
         call      DekNum                   ; dekdovn spnosti

; ------ vzva k vloen dal diskety

TestV4:  mov       si,offset TstVTxt2
         mov       di,offset TstVMnu2
         call      Menu                     ; volba dal operace
         call      XchgDsk                  ; vmna diskety
         jnc       TestV4
         cmp       al,"K"
         je        TestV6                   ; konec
         cmp       al,"D"
         jne       TestV2

; ------ dal disketa - test shodnosti parametr diskety

TestV5:  call      ReadBoot
         jc        TestV4                   ; peruen
         call      CompDisk                 ; porovnn parametr disku
         jnc       TestV3                   ; naten dal diskety

; ------ disketa nen shodn

         mov       si,offset FrmSTxt
         mov       di,offset FrmSTxtM
         call      Menu
         jc        TestV4                   ; peruen
         cmp       al,"O"
         je        TestV5                   ; opakovn
;         cmp       al,"N"
;         je        TestV4                   ; nvrat
         jmp       short TestV4
;TestV52: jmp       short TestV2             ; peruen

; ------ jsou ji vechny diskety - test vsledku testu

TestV6:  mov       si,offset TstV4Txt       ; chyba dat
         mov       ax,ds:[UspechS]
         cmp       ax,ds:[CelkSkt0]
         jb        TestV8
         mov       si,offset TstV3Txt
TestV8:  call      StdOut                   ; hlen
         ret

TestV    ENDP

; *****************************************************************************
;
;                        Funkce testu jedn diskety
;
; *****************************************************************************
;
Test1    PROC      NEAR

; ------ zobrazen vodn vzvy

         mov       si,offset Tst1Txt
         call      StdOutT                  ; zobrazen vzvy k vloen diskety
Test11:  mov       si,offset IdntTxt1
         mov       di,offset IdntMnu1
         call      Menu
         cmp       al,"D"
         je        Test13
         call      XchgDsk                  ; zmna mechaniky
         jnc       Test11                   ; byl povel "M"
         jmp       INT23

; ------ pihlen diskety

Test13:  call      ReadBoot                 ; inicializace diskety
         call      InitDisk                 ; inicializace diskovch parametr
         call      VolParit                 ; korekce jmenovky pro paritn disk

; ------ naten diskety

         call      CtiDisk                  ; naten disku
         jmp       short Test11

Test19:  ret

Test1    ENDP

; *****************************************************************************
;
;                        Identifikan kd jedn diskety
;
; *****************************************************************************
;
Ident    PROC      NEAR

; ------ zobrazen vodn vzvy

         mov       si,offset IdntTxt
         call      StdOutT                  ; zobrazen vzvy k vloen diskety
Ident1:  mov       si,offset IdntTxt1
         mov       di,offset IdntMnu1
         call      Menu
         cmp       al,"D"
         je        Ident3
         call      XchgDsk                  ; zmna mechaniky
         jnc       Ident1                   ; byl povel "M"
         jmp       INT23

; ------ inicializace diskety

Ident3:  call      ReadBoot                 ; inicializace diskety
         call      InitDisk                 ; inicializace diskovch parametr
         call      VolParit                 ; korekce jmenovky pro paritn disk

; ------ naten stopy

         mov       ch,0                     ; ukazatel sla vlce
         mov       dh,0                     ; ukazatel sla strany
         call      Inst1E                   ; instalace INT 1Eh
         call      ReadTrck                 ; naten stopy
         call      DIns1E

; ------ identifikan kd diskety

         call      SumEDCI                  ; identifikan kd
         inc       word ptr ds:[NDisket]    ; zven sla diskety
         call      DekNDisk                 ; dekdovn sla diskety
         mov       si,offset IdntTxt2       ; text
         call      StdOut0                  ; zobrazen textu
         jmp       short Ident1             ; dal disketa

Ident    ENDP

; *****************************************************************************
;
;                       Obslun procedury funkc
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;     naten cel diskety s funkc XOR (neuchovv registry !) (CY peruen)
; -----------------------------------------------------------------------------

CtiDisk  PROC      NEAR

; ------ pprava k operaci naten disku

         call      Inst1E                   ; instalace INT 1Eh
         mov       ch,0                     ; ukazatel sla vlce
CtiDisk2:mov       dh,0                     ; ukazatel sla strany

; ------ naten jedn stopy

CtiDisk3:call      ReadTrck                 ; naten stopy
         call      TstBreak
         jc        CtiDisk8                 ; peruen
         call      SetEMap                  ; nastaven mapy chyb

; ------ identifikan kd diskety

         mov       al,ch
         or        al,dh                    ; je stopa 0/strana 0 ?
         jnz       CtiDisk4                 ; nen stopa 0/strana 0
         call      SumEDCI                  ; identifikan kd

; ------ kontroln souet stopy

CtiDisk4:call      CheckSm0                 ; kontroln souet stopy

; ------ proveden operace XOR paritn diskety s natenmi daty

         test      byte ptr ds:[Operace],bit3 ; je verifikace diskety ?
         jnz       CtiDisk5                 ; je verifikace

         xor       si,si                    ; ukazatel adresy
         mov       al,ds:[NumSekt]          ; poet sektor na stopu
         call      XORSekt                  ; proveden operace XOR

; ------ identifikan kd paritn diskety

         mov       al,ch
         or        al,dh                    ; je stopa 0/strana 0 ?
         jnz       CtiDisk5                 ; nen stopa 0/strana 0

         mov       es,ds:[BuffDat]          ; buffer stopy
         xor       bx,bx
         call      SetSekt                  ; nastaven parametr BOOT sektoru
         call      SumEDCP                  ; identifikan kd parit. diskety

; ------ zven ukazatele sla strany

CtiDisk5:call      TestEsc                  ; test peruen
         jc        CtiDisk8                 ; je peruen operace
         inc       dh                       ; zven sla strany
         cmp       dh,ds:[NumStran]
         jb        CtiDisk3                 ; ten dal strany

; ------ zven ukazatele sla stopy

         inc       ch                       ; zven sla stopy
         cmp       ch,ds:[NumStop]
         jb        CtiDisk2                 ; ten dal stopy

CtiDisk8:call      TempWrit                 ; zpis dat do souboru
         call      MazText
         call      DIns1E

         call      TstBreak                 ; test peruen operace
         jc        CtiDisk9                 ; peruen operace

         call      TempXchg                 ; zaazen diskety
         inc       word ptr ds:[NDisket]    ; zven sla diskety
         call      DekNDisk                 ; dekdovn sla diskety
         call      DispEDC                  ; zobrazen kontrolnho soutu
         clc
CtiDisk9:ret

CtiDisk  ENDP

; -----------------------------------------------------------------------------
;        nastaven mapy chyb podle chyb stopy CH/strana DH
; -----------------------------------------------------------------------------

SetEMap  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      di

; ------ vpoet absolutnho sektoru

         mov       al,ch                    ; stopa
         mul       byte ptr ds:[NumStran]   ; slo stopy absolutn
         add       al,dh                    ; piten sla strany
         adc       ah,0
         mov       cl,ds:[NumSekt]          ; poet sektor na stopu
         mov       ch,0
         mul       cx                       ; vpoet absolutnho sektoru

; ------ adresa v map chyb

         mov       cl,al
         and       cl,7                     ; offset v bajtu
         shr       ax,1
         shr       ax,1
         shr       ax,1                     ; offset v map
         add       ax,offset ErrMap         ; adresa v map chyb
         xchg      ax,di                    ; DI <- ukazatel v map chyb

; ------ pprava k dekdovn mapy chyb

         mov       si,offset TrckMap        ; mapa stopy
         mov       dl,ds:[NumSekt]          ; poet sektor na stopu
         mov       ch,1                     ; maska
         shl       ch,cl                    ; rotace masky na pozici

; ------ nastaven mapy

SetEMap2:cmp       byte ptr ds:[si],0       ; byla chyba ?
         je        SetEMap3                 ; nebyla chyba
         or        byte ptr ds:[di],ch      ; nastaven pznaku chyby
SetEMap3:inc       si
         shl       ch,1
         jnc       SetEMap4
         mov       ch,1
         inc       di
SetEMap4:dec       dl
         jnz       SetEMap2

; ------ nvrat registr

         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

SetEMap  ENDP

; -----------------------------------------------------------------------------
;        zpis cel diskety (neuchovv registry !) -> CY peruen
; -----------------------------------------------------------------------------

ZapDisk  PROC      NEAR

; ------ pprava k zpisu diskety

         call      Inst1E
         mov       ch,0                     ; ukazatel sla vlce
ZapDisk2:mov       dh,0                     ; ukazatel sla strany

; ------ naten stopy z pechodnho souboru

ZapDisk3:call      ReadTTrc                 ; naten stopy z pech. bufferu
         mov       al,ch
         or        al,dh                    ; je prvn stopa ?
         jnz       ZapDisk4                 ; nen prvn stopa

; ------ korekce pro prvn stopu

         mov       es,ds:[BuffDisk]         ; buffer stopy
         xor       bx,bx
         call      SetSekt                  ; nastaven parametr BOOT sektoru
         call      SumEDCI                  ; identifikan kd
         call      SumEDCP                  ; kd paritn diskety

; ------ kontroln souet diskety

ZapDisk4:call      CheckSm0                 ; kontroln souet stopy

; ------ zpis stopy na disketu

         call      WritTrck                 ; zpis stopy
         jc        ZapDisk8                 ; peruen operace
         call      TestEsc                  ; test peruen
         jc        ZapDisk8                 ; je peruen operace

; ------ zven ukazatele sla strany

         inc       dh                       ; zven sla strany
         cmp       dh,ds:[NumStran]
         jb        ZapDisk3                 ; zpis dal strany

; ------ zven ukazatele sla stopy

         inc       ch                       ; zven sla stopy
         cmp       ch,ds:[NumStop]
         jb        ZapDisk2                 ; ten dal stopy

ZapDisk8:call      MazText
         call      DIns1E                   ; odinstalovn INT 1Eh

; ------ zobrazen informanho textu

         call      TstBreak
         jc        ZapDisk9                 ; peruen
         inc       word ptr ds:[NDisket]    ; zven sla diskety
         call      DekNDisk                 ; dekdovn sla diskety
         call      DispEDC                  ; zobrazen kontrolnho soutu
         clc
ZapDisk9:ret

ZapDisk  ENDP

; -----------------------------------------------------------------------------
; operace XOR AL sektor SI s bufferem (posouv se ukazatel) DH=strana, CH=stopa
; -----------------------------------------------------------------------------

XORSekt  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ pprava registr

         mov       bl,dh                    ; strana
         mov       bh,ch                    ; stopa
         mov       dh,0
         mov       dl,al                    ; poet sektor

; ------ proveden operace XOR s jednm sektorem

XORSekt2:push      ds
         cld
         xor       di,di
         mov       es,ds:[BuffUkaz]         ; ukazatel sektoru
         mov       ds,ds:[BuffDisk]         ; buffer stopy
         mov       cx,100h                  ; 256 slov
XORSekt3:lodsw                              ; naten slova
         xor       es:[di],ax               ; XOR
         inc       di
         inc       di
         loop      XORSekt3                 ; dal slovo
         pop       ds

; ------ zjitn, zda je sektor = 0

         test      byte ptr ds:[Operace],bit2 ; je test vech disket ?
         jz        XORSekt4                 ; nen test vech disket

         xor       ax,ax
         or        bx,bx                    ; je BOOT stopa ?
         jnz       XORSkt32                 ; nen BOOT stopa
         cmp       si,512+2                 ; je BOOT sektor ?
         ja        XORSkt32                 ; nen BOOT sektor

         test      byte ptr ds:[Param],bit3 ; nekompatibiln BOOT ?
         jnz       XORSkt32                 ; nekompatibiln BOOT

         mov       es:[0bh],ax              ; poet bajt na sektor
         mov       es:[18h],ax              ; poet sektor na stopu
         mov       es:[1ah],ax              ; poet stran
         mov       es:[13h],ax              ; celkov poet sektor

XORSkt32:xor       di,di
         mov       ch,1                     ; 256 slov
         repe      scasw                    ; test, zda je 0
         jne       XORSekt4                 ; sektor nen = 0
         inc       word ptr ds:[UspechS]    ; ta spnch sektor

; ------ posun ukazatele k dalmu sektoru

XORSekt4:add       word ptr ds:[BuffUkaz],512/16 ; zven ukazatele v bufferu
         dec       word ptr ds:[BuffCit]    ; snen tae zbylch sektor
         jnz       XORSekt5                 ; jsou dal sektory
         call      TempWrit                 ; zpis dat do souboru
         call      TempRead                 ; naten dalho bloku dat
XORSekt5:dec       dx                       ; ta sektor
         jnz       XORSekt2                 ; dal sektor

; ------ nvrat registr

         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

XORSekt  ENDP

; -----------------------------------------------------------------------------
;        inicializace diskovch parametr
; -----------------------------------------------------------------------------

InitDisk PROC      NEAR

; ------ schova registr

         push      ax

; ------ poet sektor na stopu

         mov       al,ds:[NumSekt0]
         mov       ds:[NumSekt],al          ; poet sektor na stopu
         mov       ds:[LastSekt],al         ; posledn sektor na stop

; ------ poet stran disku

         mov       al,ds:[NumStrn0]
         mov       ds:[NumStran],al         ; poet stran disku

; ------ celkem sektor

         mov       ax,ds:[CelkSkt0]
         mov       ds:[CelkSekt],ax         ; celkem sektor

; ------ poet vlc disku

         mov       al,ds:[NumStop0]
         mov       ds:[NumStop],al          ; poet stop

; ------ nvrat registr

         pop       ax
         ret

InitDisk ENDP

; -----------------------------------------------------------------------------
;        porovnn parametr diskety (CY=nen shoda)
; -----------------------------------------------------------------------------

CompDisk PROC      NEAR

; ------ schova registr

         push      ax

; ------ poet sektor na stopu

         mov       al,ds:[NumSekt0]
         cmp       al,ds:[NumSekt]          ; poet sektor na stopu
         jne       CompDsk1

; ------ poet stran disku

         mov       al,ds:[NumStrn0]
         cmp       al,ds:[NumStran]         ; poet stran disku
         jne       CompDsk1

; ------ celkem sektor

         mov       ax,ds:[CelkSkt0]
         cmp       ax,ds:[CelkSekt]         ; celkem sektor
         je        CompDsk2

; ------ nvrat registr

CompDsk1:stc                                ; pznak neshody parametr
CompDsk2:pop       ax
         ret

CompDisk ENDP

; -----------------------------------------------------------------------------
;        naten BOOT sektoru (CY=peruen)
; -----------------------------------------------------------------------------
;
ReadBoot PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ instalace tabulky 1E

         call      Inst1E                   ; instalace INT 1Eh

; ------ zobrazen hlen o natn parametr diskety

ReadBot1:mov       si,offset InitTxt
         call      StdErrA                  ; zobrazen hlen o natn

; ------ naten BOOT sektoru diskety

         xor       bx,bx                    ; offset bufferu
         mov       es,ds:[BuffDisk]         ; segment bufferu
         mov       cx,1                     ; stopa=0, sektor=1
         mov       dh,0                     ; strana=0
         mov       al,1                     ; poet sektor
         call      ReadSekt                 ; naten BOOT sektoru
         jnc       ReadBot3                 ; operace OK
         call      TstBreak                 ; test peruen
         jnc       ReadBt12
         jmp       ReadBot8
;         jc        ReadBot8                 ; peruen operace

; ------ vynulovn sektoru pi chyb

ReadBt12:call      MazText                  ; vymazn hlen
         mov       al,0                     ; nulovac bajt
         call      NulSekt                  ; nulovn sektoru
         call      SetSekt                  ; nastaven parametr BOOT sektoru

; ------ pi chyb dotaz na dal operaci

         mov       si,offset ErrBTxt
         mov       di,offset ErrBTxtM
         call      Menu                     ; volba dal operace
         cmp       al,"O"
         je        ReadBot1                 ; opakovn operace
         cmp       al,"D"
         je        ReadBt22                 ; dle, cbyba se ignoruje
ReadBot2:jmp       Prerus                   ; konec programu

; ------ kontrola platnosti parametr sektoru

ReadBt22:call      StdErrO                  ; obnoven aktulnho hlen
ReadBot3:and       byte ptr ds:[Param],not bit3
         call      TestDisk                 ; test parametr disku
         jnc       ReadBot4                 ; parametry diskety jsou OK

         or        byte ptr ds:[Param],bit3 ; nekompatibiln BOOT

         mov       byte ptr ds:[NumSekt0],8 ; poet sektor na stopu
         mov       byte ptr ds:[NumStrn0],1 ; poet stran disku
         mov       word ptr ds:[CelkSkt0],8*40 ; celkem sektor
         mov       byte ptr ds:[NumStop0],40 ; poet stop

;         call      MazText                  ; vymazn hlen
;         mov       si,offset FormTxt
;         mov       di,offset FormTxtM
;         call      Menu                     ; volba
;         cmp       al,"O"
;         je        ReadBot1                 ; opakovn
;         jmp       short ReadBot2           ; peruen

; ------ vymazn bufferu jmenovky diskety

ReadBot4:push      es
         push      ds
         pop       es                       ; ES <- datov segment
         mov       bx,offset MazTTxt1       ; sam mezery
         call      CopyLab                  ; kopie do buffer
         pop       es

; ------ inicializace jmenovky disky, test paritn diskety

         test      byte ptr ds:[Param],bit3 ; nekompatibiln BOOT ?
         jnz       ReadBt52                 ; je nekompatibiln BOOT
         or        byte ptr ds:[Param],bit4 ; je paritn disketa
         cmp       byte ptr es:[10h],0      ; je poloka tabulek FAT ?
         je        ReadBot6                 ; zejm to je sud paritn disketa
         mov       bx,2bh                   ; jmenovka pro DOS 4
         cmp       byte ptr es:[bx+26h-2bh],29h ; je to rozen sektor ?
         je        ReadBot5                 ; je jmenovka diskety
         call      ReadLab                  ; naten jmenovky diskety -> BX
         jc        ReadBt52                 ; chyba, ale asi nen paritn disk
ReadBot5:call      TestLab                  ; test jmenovky diskety ES:BX
         jc        ReadBot6                 ; jmenovka neplat, asi paritn disk
         call      CopyLab                  ; kopie jmenovky disku ES:BX
ReadBt52:and       byte ptr ds:[Param],not bit4 ; zejm nen paritn disketa

; ------ jmenovka NO NAME je neplatn

ReadBot6:call      VolParit                 ; korekce pro paritn disketu
         push      ds
         pop       es
         mov       si,offset NoNamTxt       ; jmenovka "NO NAME"
         mov       di,offset CtuTxt1
         mov       cx,11
         cld
         repe      cmpsb                    ; je to jmenovka NO NAME ?
         jne       ReadBot7                 ; nen NO NAME
         mov       bx,offset MazTTxt1       ; sam mezery
         call      CopyLab                  ; vymazn jmenovky

; ------ inicializace ukazatel disku

ReadBot7:call      TstBreak
         jc        ReadBot8                 ; peruen
         call      TempRes                  ; resetovn pechodnho souboru
         call      TempRead                 ; naten pechodnho souboru
         mov       word ptr ds:[EDC],-1     ; inicializan hodnota EDC
         mov       word ptr ds:[EDCIdent],-1 ; identifikan kd diskety
         call      DekEDCI                  ; dekdovn identifikanho kdu
         call      MazText                  ; vymazn dku hlen
         call      DIns1E                   ; odinstalovn tabulky INT 1Eh
         call      DekFDsk                  ; dekdovn formtu disku

; ------ nvrat registr

ReadBot8:call      TstBreak                 ; test peruen
         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

ReadBoot ENDP

; -----------------------------------------------------------------------------
;        test jmenovky disku ES:BX -> CY neplatn
; -----------------------------------------------------------------------------

TestLab  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      si

; ------ test jmenovky, zda nen < 32 a zda to nejsou mal psmena

         mov       cx,11
         cmp       byte ptr es:[bx]," "+1   ; prvn znak nesm bt ani mezera
         jb        TestLab9                 ; zakzan znak
TestLab1:mov       al,es:[bx]
         inc       bx
         cmp       al," "
         jb        TestLab9
         cmp       al,"a"
         jb        TestLab2
         cmp       al,"z"+1
         jb        TestLab9

; ------ test jmenovky podle tabulky zakzanch znak

TestLab2:mov       si,offset BlokTab        ; tabulka zakzanch znak
TestLab3:cmp       al,cs:[si]
         stc
         je        TestLab9                 ; zakzan znak
         inc       si
         cmp       byte ptr cs:[si],0
         jne       TestLab3
         loop      TestLab1
;         clc                                ; pznak operace OK

; ------ nvrat registr

TestLab9:pop       si
         pop       cx
         pop       bx
         pop       ax
         ret

TestLab  ENDP

BlokTab  db        '"*+,./:;<=>?[\]|',0

; -----------------------------------------------------------------------------
;        kopie jmenovky ES:BX do buffer
; -----------------------------------------------------------------------------

CopyLab  PROC      NEAR

         push      di
         mov       di,offset CtuTxt1
         call      CopyLab0
         mov       di,offset ZapTxt1
         call      CopyLab0
         mov       di,offset NactTxt1
         call      CopyLab0
         mov       di,offset IdntTx22
         call      CopyLab0
         pop       di
         ret

CopyLab  ENDP

CopyLab0:push      cx
         push      si
         push      ds
         push      es

         push      ds
         push      es
         pop       ds                       ; DS <- segment bufferu
         pop       es                       ; ES <- datov segment
         mov       si,bx                    ; SI <- offset vzoru jmenovky
         mov       cx,11
         cld
         rep       movsb

         pop       es
         pop       ds
         pop       si
         pop       cx
         ret

; -----------------------------------------------------------------------------
;        naten jmenovky disku z ROOT
; -----------------------------------------------------------------------------
; VSTUP: ES=segment natenho BOOT sektoru
; VSTUP: BX=offset nalezen jmenovky disku
;         CY=chyba, peruen nebo jmenovka nenalezena
; -----------------------------------------------------------------------------

ReadLab  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      bp

; ------ zjitn potu sektor ROOT

         test      byte ptr ds:[Param],bit3
         jnz       ReadLab0                 ; neplatn BOOT

         mov       bp,es:[11h]              ; poet poloek ROOT
         shr       bp,1
         shr       bp,1
         shr       bp,1
         shr       bp,1                     ; poet sektor ROOT
         jnz       ReadLab1
ReadLab0:jmp       ReadLab8                 ; neplatn poet poloek ROOT

; ------ zjitn potenho sektoru ROOT

ReadLab1:cmp       byte ptr es:[10h],2      ; jsou 2 tabulky FAT ?
         jne       ReadLab8                 ; nekompatibiln disketa
         mov       ax,es:[16h]              ; poet sektor jedn tabulky FAT
         shl       ax,1                     ; poet sektor na ob tabulky FAT
         jc        ReadLab8                 ; chyba
         add       ax,es:[0eh]              ; piten rezervovanch sektor
         jc        ReadLab8

; ------ kontrola peteen konce ROOT pes konec disku

         mov       cx,ax
         add       cx,bp                    ; piten potu sektor ROOT
         jc        ReadLab8
         cmp       cx,es:[13h]              ; kontrola peteen konce disku
         jae       ReadLab8                 ; peteen konce disku

; ------ pepoet na ukazatele sektoru BIOS

         mov       cl,ds:[NumSekt0]         ; poet sektor na stopu
         cmp       byte ptr ds:[NumStrn0],2 ; jsou 2 strany ?
         jb        ReadLab2                 ; nejsou 2 strany
         shl       cl,1                     ; poet sektor pro 2 strany
ReadLab2:div       cl                       ; vpoet sla vlce
         mov       ch,al                    ; CH <- slo vlce
         mov       al,ah                    ; AL <- sektor na vlci
         mov       ah,0
         div       byte ptr ds:[NumSekt0]   ; vydlen potem sektor na stopu
         mov       cl,ah                    ; slo sektoru
         inc       cx                       ; korekce sla sektoru
         mov       dh,al                    ; slo strany

; ------ naten 1 sektoru do bufferu

ReadLab3:xor       bx,bx
         mov       al,1                     ; 1 sektor
         call      ReadSekt                 ; naten 1 sektoru ROOT
         jc        ReadLab8                 ; njak chyba

; ------ prohledn jednoho sektoru

         mov       si,16                    ; poet poloek na sektor
ReadLab4:cmp       byte ptr es:[bx],0
         je        ReadLab8                 ; konec adrese
         cmp       byte ptr es:[bx],0e5h
         je        ReadLab5                 ; zruen poloka
         test      byte ptr es:[bx+0bh],bit3 ; je to nvt disku ?
         jnz       ReadLab9                 ; nvt disku nalezeno OK
ReadLab5:add       bx,32                    ; adresa dal poloky
         dec       si
         jnz       ReadLab4                 ; test dal poloky

; ------ ta zbylch sektor ROOT

         dec       bp                       ; ta sektor ROOT
         jz        ReadLab8                 ; nen dal sektor

; ------ zven sla sektoru

         inc       cx
         cmp       cl,ds:[NumSekt0]         ; je ji konec stopy ?
         jbe       ReadLab3                 ; naten dalho sektoru
         mov       cl,1

; ------ zven sla strany

         inc       dh                       ; zven sla strany
         cmp       dh,ds:[NumStrn0]         ; jsou ji vechny strany ?
         jb        ReadLab3                 ; naten dalho sektoru
         mov       dh,0

; ------ zven sla stopy

         inc       ch
         jmp       short ReadLab3

; ------ nvrat registr

ReadLab8:stc
ReadLab9:pop       bp
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

ReadLab  ENDP

; -----------------------------------------------------------------------------
;        test parametr disku ES:BX (z natenho BOOT sektoru) -> CY chyba
; -----------------------------------------------------------------------------

TestDisk PROC      NEAR

         push      ax
         push      cx
         push      dx

; ------ velikost sektoru

         cmp       word ptr es:[bx+0bh],512 ; poet bajt na sektor
         jne       TestDsk8

; ------ poet sektor na stopu

         mov       ax,es:[bx+18h]           ; poet sektor na stopu
         cmp       ax,MAXSEKT               ; maximum sektor
         ja        TestDsk8
         cmp       al,6                     ; minimum sektor
         jb        TestDsk8
         mov       ds:[NumSekt0],al         ; poet sektor na stopu
         xchg      ax,cx                    ; CX <- poet sektor na stopu

; ------ poet stran disku

         mov       ax,es:[bx+1ah]           ; poet stran disku
         cmp       ax,2                     ; maximum stran
         ja        TestDsk8
         cmp       al,1                     ; minimum stran
         jb        TestDsk8
         mov       ds:[NumStrn0],al         ; poet stran disku
         je        TestDsk3                 ; je 1 strana
         shl       cx,1                     ; poet sektor pro 2 strany

; ------ poet vlc disku

TestDsk3:mov       ax,es:[bx+13h]           ; celkov poet sektor
         mov       ds:[CelkSkt0],ax         ; celkem sektor
         add       ax,cx                    ; penos pro zaokrouhlen
         dec       ax
         xor       dx,dx
         div       cx                       ; vpoet potu vlc
         cmp       ax,MAXTRACK              ; maximln poet stop
         ja        TestDsk8
         cmp       al,35                    ; minimln poet stop
         jb        TestDsk8
         mov       ds:[NumStop0],al         ; poet stop
         jmp       short TestDsk9

; ------ chyba parametr diskety

TestDsk8:stc
TestDsk9:pop       dx
         pop       cx
         pop       ax
         ret

TestDisk ENDP

; -----------------------------------------------------------------------------
;        nastaven parametr BOOT sektoru ES:BX
; -----------------------------------------------------------------------------

SetSekt  PROC      NEAR

         push      ax

         test      byte ptr ds:[Param],bit3
         jnz       SetSekt2                 ; neplatn BOOT

         mov       word ptr es:[bx+0bh],512 ; poet bajt na sektor
         mov       ah,0
         mov       al,ds:[NumSekt]
         mov       es:[bx+18h],ax           ; poet sektor na stopu
         mov       al,ds:[NumStran]
         mov       es:[bx+1ah],ax           ; poet stran
         mov       ax,ds:[CelkSekt]
         mov       es:[bx+13h],ax           ; celkov poet sektor

SetSekt2:pop       ax
         ret

SetSekt  ENDP

; *****************************************************************************
;
;                   Univerzln obsluha diskety
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        instalace tabulky INT 1Eh
; -----------------------------------------------------------------------------

Inst1E   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ test, zda je tabulka ji nainstalovna

         test      byte ptr ds:[Param],bit6 ; je nainstalovn ?
         jnz       Inst1E4                  ; je ji nainstalovn

; ------ schova adresy INT 1Eh

         mov       ax,351eh
         int       21h                      ; poskytnut adresy INT 1Eh
         mov       word ptr ds:[Old1E],bx
         mov       word ptr ds:[Old1E+2],es

; ------ penos tabulky do vlastnho bufferu

         push      ds
         push      es
         push      ds
         pop       es                       ; ES <- datov segment
         pop       ds                       ; DS <- segment tabulky
         mov       si,bx                    ; SI <- offset tabulky
         mov       di,offset Tab1E          ; vlastn tabulka INT 1Eh
         mov       dx,di                    ; adresa tabulky
         mov       cx,offset(Tab1E0-Tab1E)  ; dlka tabulky
         cld
         rep       movsb                    ; schova tabulky
         pop       ds

; ------ pedefinovn adresy INT 1Eh

         mov       ax,251eh
         int       21h                      ; definice adresy INT 1Eh
         or        byte ptr ds:[Param],bit6 ; pznak nainstalovn

; ------ pedefinovn potu sektor na stopu

Inst1E4: mov       al,ds:[NumSekt]          ; poet sektor na stopu
         mov       ds:[LastSekt],al         ; posledn sektor na stop
         mov       byte ptr ds:[SektSize],2 ; velikost sektoru 512 bajt

; ------ nvrat registr

         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

Inst1E   ENDP

; -----------------------------------------------------------------------------
;        odinstalovn tabulky INT 1Eh
; -----------------------------------------------------------------------------

DIns1E   PROC      NEAR

         test      byte ptr ds:[Param],bit6 ; nainstalovno ?
         jz        DIns1E4                  ; INT 1Eh nen nainstalovno

         push      ax
         push      dx
         push      ds

         lds       dx,ds:[Old1E]
         mov       ax,251eh
         int       21h                      ; nvrat adresy INT 1Eh

         pop       ds
         pop       dx
         pop       ax
         and       byte ptr ds:[Param],not bit6 ; pznak, e nen instalovno
DIns1E4: ret

DIns1E   ENDP

; -----------------------------------------------------------------------------
;        zpis stopy na disketu (CH=stopa, DH=strana -> CY peruen)
; -----------------------------------------------------------------------------

WritTrck PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ zobrazen hlen o zpisu stopy

WritTrc1:mov       cl,1                     ; slo potenho sektoru
         call      PrepN13                  ; pprava sla stopy
         mov       si,offset ZapTxt
         call      StdErrA                  ; zobrazen hlen

; ------ zpis stopy vcelku

         xor       bx,bx                    ; offset bufferu
         mov       es,ds:[BuffDisk]         ; adresa bufferu
         mov       al,ds:[NumSekt]          ; poet sektor na stopu
         call      WritSekt                 ; zpis dat z bufferu
         jc        WritTrc2                 ; chyba zpisu

; ------ zptn naten stopy

         mov       es,ds:[BuffDskV]         ; buffer verifikovan stopy
         call      ReadSekt                 ; naten stopy zpt
         jc        WritTrc2                 ; chyba zpisu

; ------ porovnn dat stopy

         push      cx
         push      ds
         xor       si,si
         xor       di,di
         mov       ch,al                    ; CH <- poet sektor
         mov       cl,0
         mov       ds,ds:[BuffDisk]         ; zpisov buffer
         cld
         repe      cmpsw                    ; porovnn dat
         pop       ds
         pop       cx
         je        WritTrc8                 ; operace OK

; ------ hlen chyby

WritTrc2:call      TstBreak                 ; test peruen
         jc        WritTrc8                 ; je peruen
         call      MazText
         mov       di,offset Er2WMnu
         mov       si,offset Er2WTxt
         call      Menu                     ; zobrazen hlen
         jc        WritTrc8                 ; peruen
         call      StdErrO                  ; obnoven aktulnho hlen
         cmp       al,"D"
         je        WritTrc8                 ; dal sektor
         cmp       al,"S"
         jne       WritTrc1                 ; nejsou sektory - opakovn

; ------ pprava hlen pro aktuln ukazatele

WritTrc3:call      PrepN13                  ; pprava sla stopy

; ------ zpis 1 sektoru

         mov       es,ds:[BuffDisk]         ; adresa bufferu
         mov       al,1                     ; 1 sektor
         call      WritSekt                 ; zpis dat z bufferu
         jc        WritTrc5                 ; chyba zpisu

; ------ zptn naten sektoru

         mov       es,ds:[BuffDskV]         ; buffer verifikovan stopy
         call      ReadSekt                 ; naten stopy zpt
         jc        WritTrc5                 ; chyba zpisu

; ------ porovnn dat stopy

         push      cx
         push      ds
         mov       si,bx
         mov       di,bx
         mov       cx,256
         mov       ds,ds:[BuffDisk]         ; zpisov buffer
         cld
         repe      cmpsw                    ; porovnn dat
         pop       ds
         pop       cx
         je        WritTrc7                 ; operace OK

; ------ chyba - zobrazen dotazu na dal postup

WritTrc5:call      TstBreak
         jc        WritTrc8                 ; peruen
         call      MazText
         mov       di,offset ErrWMnu
         mov       si,offset ErrWTxt
         call      Menu                     ; zobrazen hlen
         jc        WritTrc8
         cmp       al,"D"
         je        WritTrc7                 ; dal sektor
;         cmp       al,"O"
;         jne       WritTrc6                 ; peruen
         call      StdErrO                  ; obnoven aktulnho hlen
         jmp       short WritTrc3

; ------ zpis dalho sektoru

WritTrc7:inc       cx                       ; zven sla sektoru
         add       bx,512                   ; zven adresy v bufferu
         cmp       cl,ds:[NumSekt]          ; jsou ji vechny sektory ?
         jbe       WritTrc3                 ; dal sektor

; ------ nvrat registr

WritTrc8:pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

WritTrck ENDP

; -----------------------------------------------------------------------------
;        ten stopy z diskety do bufferu (CH=stopa, DH=strana -> CY=peruen)
; -----------------------------------------------------------------------------

ReadTrck PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ vymazn bufferu vadnch sektor

         mov       si,offset TrckMap        ; mapa stopy
         mov       al,ds:[NumSekt]          ; poet sektor
ReadTrc1:mov       byte ptr ds:[si],0       ; oznaen sektoru OK
         inc       si
         dec       al                       ; ta sektor
         jnz       ReadTrc1

; ------ test, zda se m stopa st

         test      byte ptr ds:[Param],bit1 ; je obnovovan disketa ?
         jz        ReadTrc2                 ; nen obnovan disketa

         mov       cl,1
ReadTr12:call      TestErrM                 ; test mapy chyb
         jc        ReadTrc2                 ; je cbyba - mus se nast
         inc       cx
         cmp       cl,ds:[NumSekt]
         jbe       ReadTr12
         jmp       ReadTrc8                 ; nen teba st

; ------ zobrazen hlen o ten stopy

ReadTrc2:mov       es,ds:[BuffDisk]         ; adresa bufferu
         mov       cl,1                     ; slo potenho sektoru
         call      PrepN13                  ; pprava sla stopy
         mov       si,offset CtuTxt
         call      StdErrA                  ; zobrazen hlen

; ------ naten 1 stopy vcelku

ReadTr24:xor       bx,bx                    ; offset bufferu
         mov       al,ds:[NumSekt]          ; poet sektor na stopu
         call      ReadSekt                 ; naten dat do bufferu
         jnc       ReadTrc8                 ; operace OK
         call      TstBreak                 ; je peruen ?
         jc        ReadTrc8                 ; je peruen operace

; ------ pprava hlen pro aktuln ukazatele

         mov       di,offset TrckMap        ; mapa stopy
ReadTrc3:call      PrepN13                  ; pprava sla stopy

; ------ test, zda se m sektor st

         test      byte ptr ds:[Param],bit1 ; je obnovovan disketa ?
         jz        ReadTr41                 ; nen obnovan disketa
         call      TestErrM                 ; test mapy chyb
         jnc       ReadTrc7                 ; nen cbyba - nemus se nast

; ------ naten 1 sektoru

ReadTr41:mov       al,1                     ; 1 sektor
         call      ReadSekt                 ; naten sektoru
         jnc       ReadTrc7                 ; sektor naten OK
         call      TstBreak                 ; je peruen ?
         jc        ReadTrc8                 ; je peruen operace

; ------ nulovn sektoru pi chyb

         mov       al,ch
         or        al,dh                    ; je vlec 0 / strana 0 ?
         jz        ReadTr42                 ; je vlec i stopa = 0
         mov       al,0f6h                  ; nulovac bajt
ReadTr42:call      NulSekt                  ; vynulovn obsahu sektoru ES:BX

         cmp       al,0
         jne       ReadTrc4                 ; nen vlec 0, stopa 0
         cmp       cl,1
         jne       ReadTrc4                 ; nen BOOT sektor
         call      SetSekt                  ; nastaven parametr BOOT sektoru

; ------ volba dal operace pi chyb

ReadTrc4:push      di
         mov       di,offset ErrRTxtM
         mov       si,offset ErrRTxt
         call      MazText                  ; vymazn dku
         call      Menu                     ; zobrazen hlen
         pop       di
         jc        ReadTrc8                 ; peruen
         cmp       al,"D"
         je        ReadTrc6                 ; dal sektor
         call      StdErrO                  ; obnoven aktulnho hlen
         jmp       short ReadTrc3           ; opakovn operace

; ------ sektor naten s chybou

ReadTrc6:dec       byte ptr ds:[di]         ; -1 = pznak chyby operace
         call      StdErrO                  ; obnoven aktulnho hlen

; ------ 1 sektor naten OK

ReadTrc7:inc       di                       ; ukazatel v tabulce
         inc       cx                       ; zven sla sektoru
         add       bx,512                   ; zven adresy v bufferu
         cmp       cl,ds:[NumSekt]          ; jsou ji vechny sektory ?
         jbe       ReadTrc3                 ; dal sektor

; ------ nvrat registr

ReadTrc8:pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

ReadTrck ENDP

; -----------------------------------------------------------------------------
;        nulovn sektoru ES:BX bajtem AL
; -----------------------------------------------------------------------------

NulSekt  PROC      NEAR

         push      ax
         push      cx
         push      di

         mov       ah,al
         mov       cx,512/2
         mov       di,bx
         cld
         rep       stosw

         pop       di
         pop       cx
         pop       ax
         ret

NulSekt  ENDP

; -----------------------------------------------------------------------------
;        zpis dat na disketu (2 pokusy)
; -----------------------------------------------------------------------------
; VSTUP: CH=stopa
;        CL=sektor
;        DH=strana
;        AL=poet sektor
;        ES:BX=adresa bufferu
; VSTUP: CY=chyba
; -----------------------------------------------------------------------------

WritSekt PROC      NEAR

         push      ax
         mov       ah,3
         jmp       short ReadSek2

WritSekt ENDP

; -----------------------------------------------------------------------------
;        ten dat z diskety (2 pokusy)
; -----------------------------------------------------------------------------
; VSTUP: CH=stopa
;        CL=sektor
;        DH=strana
;        AL=poet sektor
;        ES:BX=adresa bufferu
; VSTUP: CY=chyba
; -----------------------------------------------------------------------------

ReadSekt PROC      NEAR

         test      byte ptr ds:[Param],bit2 ; je uren paritn disketa ?
         jz        ReadSek1
         cmp       word ptr ds:[OutpIdnt],0 ; je vstupn soubor oteven ?
         jne       ReadOutp                 ; je vstupn soubor oteven

ReadSek1:push      ax
         mov       ah,2                     ; funkce ten sektor

ReadSek2:push      bp
         mov       bp,2                     ; poet pokus
ReadSek3:call      Int13                    ; naten sektor do bufferu
         jnc       ReadSek4
         dec       bp                       ; ta pokus
         jnz       ReadSek3
ReadSek4:pop       bp
         pop       ax
         ret

ReadSekt ENDP

; ------ ten ze vstupnho souboru

ReadOutp:push      ax
         push      bx
         push      cx
         push      dx

; ------ pepoet na absolutn sektor

         push      ax
         push      bx

         mov       al,ch                    ; slo vlce
         mul       byte ptr ds:[NumStran]   ; pepoet na absolutn stopu
         add       al,dh                    ; piten strany
         mov       dh,0
         adc       ah,dh
         mov       dl,ds:[NumSekt]          ; poet sektor na stopu
         mul       dx                       ; pepoet na sektory
         dec       cx                       ; korekce sla sektoru
         add       al,cl                    ; piten sla sektoru
         adc       ah,0

; ------ pepoet na offset v souboru

         mov       ch,0
         mov       cl,ah                    ; CX:DX = sektor*256
         mov       dh,al
         mov       dl,0
         shl       dh,1
         rcl       cl,1
         rcl       ch,1                     ; offset v souboru

; ------ nastaven ukazatele v souboru

         mov       ax,4200h
         mov       bx,ds:[OutpIdnt]         ; identifiktor souboru
         int       21h                      ; nastaven ukazatele v souboru

         pop       dx
         pop       ax
         jc        ReadOut4                 ; chyba operace

; ------ stanoven velikosti dat k naten

         mov       ch,al                    ; poet sektor
         mov       cl,0
         shl       cx,1                     ; poet bajt k naten

; ------ naten dat do bufferu

         push      ds
         push      es
         pop       ds                       ; DS <- segment bufferu
         mov       ah,3fh
         int       21h                      ; naten dat ze souboru
         pop       ds
         jnc       ReadOut5

; ------ chyba ten ze souboru

ReadOut4:mov       si,offset ErrORTxt
         jmp       Chyba

; ------ nvrat registr

ReadOut5:pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

; -----------------------------------------------------------------------------
;        pprava sla stopy pro operaci
; -----------------------------------------------------------------------------

PrepN13  PROC      NEAR

         push      ax

; ------ slo vlce

         mov       al,ch                    ; slo vlce
         aam
         xchg      al,ah
         add       ax,"00"
         mov       word ptr ds:[CtuTxt2],ax ; slo vlce
         mov       word ptr ds:[ZapTxt2],ax ; slo vlce
         mov       word ptr ds:[ErrRTxt1+19],ax
         mov       word ptr ds:[ErrWTxt1+20],ax
         mov       word ptr ds:[Er2WTxt1+20],ax

; ------ slo strany

         mov       al,dh                    ; slo strany
         add       al,"0"
         mov       ds:[CtuTxt3],al
         mov       ds:[ZapTxt3],al
         mov       ds:[ErrRTxt1+29],al
         mov       ds:[ErrWTxt1+30],al
         mov       ds:[Er2WTxt1+30],al

; ------ slo sektoru

         mov       al,cl
         aam
         xchg      al,ah
         add       ax,"00"
         mov       word ptr ds:[ErrRTxt1+38],ax
         mov       word ptr ds:[ErrWTxt1+39],ax

; ------ nvrat registr

         pop       ax
         ret

PrepN13  ENDP

; -----------------------------------------------------------------------------
;        reset disku
; -----------------------------------------------------------------------------

ResDisk  PROC      NEAR

         push      ax
         mov       ah,0
         call      Int13                    ; reset diskety
         pop       ax
         ret

ResDisk  ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 13h s schovou vech registr (CY=chyba nebo peruen)
; -----------------------------------------------------------------------------

Int13    PROC      NEAR

; ------ schova registr

         push      bp
         mov       bp,2                     ; ta pokus

Int131:  push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ obsluha poadovan funkce

         clc
         sti
         mov       dl,ds:[Disk]             ; slo disku
         int       13h

; ------ nvrat registr

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         jnc       Int133                   ; operace OK

; ------ opakovn operace pi vmn diskety

         cmp       ah,6                     ; je vmna diskety ?
         jne       Int132                   ; nen vmna diskety
         dec       bp                       ; ta pokus
         jnz       Int136                   ; dal pokus

; ------ test, zda je zkaz zpisu

Int132:  cmp       ah,3
         je        Int1332                  ; zkaz zpisu

; ------ test, zda je chyba TIME-OUT

         cmp       ah,80h                   ; chyba TIME-OUT ?
         je        Int134                   ; nen chyba TIME-OUT
         stc
Int133:  pop       ax
         pop       bp
         ret

; ------ disketa je R/O

Int1332: push      si
         push      di
         mov       si,offset ErrROTxt
         mov       di,offset ErrROMnu
         jmp       short Int1342

; ------ dotaz na dal operaci

Int134:  push      si
         push      di
         mov       si,offset ErrTTxt
         mov       di,offset ErrTMnu
Int1342: call      MazText                  ; vymazn textu
         call      Menu                     ; zobrazen textu
         pop       di
         pop       si
         jc        Int137                   ; peruen operace
         call      StdErrO                  ; obnoven textu

Int136:  call      ResDisk                  ; resetovn disku
         pop       ax
         jmp       short Int131             ; opakovn operace

; ------ peruen operace

Int137:  call      SetBreak                 ; pznak peruen operace
         jmp       short Int133

Int13    ENDP

; *****************************************************************************
;
;                    Obsluha zobrazen a vstupu z klvesnice
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        volba pomoc menu (text SI, definice DI -> znak AX, CY=peruen "P")
; -----------------------------------------------------------------------------

Menu     PROC      NEAR

; ------ schova registr

         push      dx
         push      bx

; ------ zobrazen celho dku textu

         call      NulBreak                 ; nulovn pznaku peruen
         mov       dl,1                     ; aktivn volba
         mov       dh,ds:[di]               ; poet voleb celkem
         call      StdErr                   ; zobrazen dku textu

; ------ ukazatel aktivn poloky

Menu1:   mov       bx,di
         add       bl,dl
         adc       bh,0
         add       bl,dl
         adc       bh,0
         dec       bx

; ------ zobrazen kurzoru

         push      word ptr ds:[si]         ; schova pvodn dlky textu
         mov       al,ds:[bx+1]             ; offset kurzoru
         mov       ds:[si],al               ; nov dlka textu
         call      StdErr                   ; zobrazen dku textu
         pop       word ptr ds:[si]

; ------ ekn na zadn klvesy

Menu2:   call      StdIn
         jnc       Menu22                   ; nen peruen
         mov       al,"P"                   ; volba peruen menu

; ------ potvrzen aktivn volby ENTER (mezera)

Menu22:  cmp       al,13
         je        Menu8                    ; potvrzen volby ENTER
         cmp       al," "
         je        Menu8                    ; potvrzen volby mezerou

; ------ prvn poloka HOME

         cmp       ax,4700h
         je        Menu3

; ------ kurzor vpravo

         cmp       al,9
         je        Menu32
         cmp       ax,4d00h
         jne       Menu4
Menu32:  inc       dx                       ; zven aktivn poloky
         cmp       dl,dh
         jbe       Menu1                    ; nen jet konec
Menu3:   mov       dl,1                     ; prvn poloka
         jmp       short Menu1

; ------ posledn poloka END

Menu4:   cmp       ax,4f00h
         je        Menu5

; ------ kurzor vlevo

         cmp       ax,0f00h
         je        Menu52
         cmp       ax,4b00h
         jne       Menu6
Menu52:  dec       dl                       ; snen aktivn poloky
         jnz       Menu1
Menu5:   mov       dl,dh
         jmp       short Menu1

; ------ nalezen hork klvesy v menu

Menu6:   push      di
         push      dx
         mov       dl,1
Menu62:  inc       di
         inc       di
         cmp       al,ds:[di-1]
         je        Menu7                    ; klvesa nalezena OK
         dec       dh
         jnz       Menu62
         pop       dx
         pop       di
         jmp       short Menu2              ; klvesa nenalezena

Menu7:   pop       dx
         pop       di
         jmp       short Menu82

; ------ zvolen klvesa

Menu8:   mov       al,ds:[bx]               ; psmeno aktivn volby
Menu82:  cmp       al,"P"
         clc
         jne       Menu9
         call      SetBreak                 ; nastaven pznaku peruen

; ------ vymazn dku textu

Menu9:   call      MazText                  ; vymazn dku textu
         mov       ah,0

; ------ nvrat registr

         pop       bx
         pop       dx
         ret

Menu     ENDP

; -----------------------------------------------------------------------------
;        test peruen operace ESC -> CY peruen
; -----------------------------------------------------------------------------

TestEsc  PROC      NEAR

         test      byte ptr ds:[Operace],bit7 ; je sporn md ?
         jnz       TestEsc9                 ; je sporn md

         mov       ah,0bh
         int       21h                      ; test klvesnice
         cmp       al,0
         je        TestEsc9                 ; nen pipraven dn znak

         mov       ah,8
         int       21h                      ; vstup znaku z klvesnice
         cmp       al,0
         jne       TestEsc2
         mov       ah,8
         int       21h
         mov       al,0

TestEsc2:cmp       al,27
         clc
         jne       TestEsc9                 ; nen ESC
         call      SetBreak                 ; nastaven pznaku peruen
TestEsc9:ret

TestEsc  ENDP

; -----------------------------------------------------------------------------
;        vstup znaku z klvesnice -> AX
; -----------------------------------------------------------------------------

StdIn    PROC      NEAR

; ------ vyprzdnn bufferu klvesnice

         push      dx
         mov       ax,0c06h
         mov       dl,0ffh
         int       21h                      ; vyprzdnn bufferu klvesnice
         pop       dx

; ------ test znaku z klvesnice

StdIn1:  mov       ah,0bh
         int       21h                      ; test znaku z klvesnice
         cmp       al,0
         jne       StdIn2                   ; je pipraven znak z klvesnice

; ------ obsluha vypnn mechaniky

         test      byte ptr ds:[Operace],bit5 ; je identifikace disket ?
         jz        StdIn1                   ; nen identifikace disket
         push      es
         xor       ax,ax
         mov       es,ax
         mov       al,ds:[MotorOff]         ; as pro vypnut motoru
         mov       es:[440h],al             ; ta pro vypnut motoru
         pop       es
         jmp       short StdIn1

; ------ vstup znaku z klvesnice

StdIn2:  mov       ah,8
         int       21h                      ; vstup znaku z klvesnice
         mov       ah,0

; ------ konverze na velk psmeno

         cmp       al,"a"
         jb        StdIn3
         cmp       al,"z"
         ja        StdIn3
         sub       al,32                    ; konverze na velk psmeno

; ------ vstup SCAN kdu dic klvesy

StdIn3:  cmp       al,0
         jne       StdIn4
         mov       ah,8
         int       21h                      ; zruen rozen klvesy
         mov       ah,al                    ; SCAN kd dic klvesy
         mov       al,0

; ------ nhrada ppadnho Ctrl-Break klvesou ESC

StdIn4:  cmp       al,3                     ; Ctrl-C
         je        StdIn5
         or        ax,ax
         jnz       StdIn6
StdIn5:  mov       al,27

; ------ pznak CY pro ESC

StdIn6:  cmp       al,27                    ; ESC
         clc
         jne       StdIn7
         stc
StdIn7:  ret

StdIn    ENDP

; -----------------------------------------------------------------------------
;        vymazn vstupnho dku (uchovv registr pznak !)
; -----------------------------------------------------------------------------

MazText  PROC      NEAR

         pushf
         push      si
         mov       si,offset MazTTxt
         call      StdErr                   ; zobrazen textu
         pop       si
         popf
         ret

MazText  ENDP

; -----------------------------------------------------------------------------
;        obnoven aktulnho hlen
; -----------------------------------------------------------------------------

StdErrO  PROC      NEAR

         push      si
         mov       si,ds:[AktHlas]          ; adresa aktulnho hlen
         call      StdErr                   ; zobrazen hlen
         pop       si
         ret

StdErrO  ENDP

; -----------------------------------------------------------------------------
;        vstup textu DS:SI na standardn chybov zazen (1. slovo = dlka)
; -----------------------------------------------------------------------------

; ------ hlen s uschovnm adresy aktulnho hlen o provdn operaci

StdErrA: mov       ds:[AktHlas],si          ; adresa aktulnho hlen
         jmp       short StdErr

; ------ hlen s pedchozm vymazn dku

StdErr0: call      MazText                  ; vymazn dku

StdErr   PROC      NEAR

         push      bx
         mov       bx,2                     ; identifiktor zazen STDERR
         jmp       short StdOut1

StdErr   ENDP

; -----------------------------------------------------------------------------
;        vstup textu DS:SI do souboru protokolu (1. slovo = dlka)
; -----------------------------------------------------------------------------

RepOut:  push      si
         mov       si,offset DatTxt0
         call      RepOut0
         pop       si

RepOut0: push      bx
         mov       bx,ds:[RepIdnt]          ; identifiktor souboru
         or        bx,bx
         jnz       StdOut1                  ; soubor je oteven
         pop       bx
         ret

; -----------------------------------------------------------------------------
;        vstup textu DS:SI na standardn vstupn zazen (1. slovo = dlka)
; -----------------------------------------------------------------------------

StdOut0: call      MazText                  ; vymazn dku
         jmp       short StdOut

StdOutT: test      byte ptr ds:[Operace],bit6 ; je tich md ?
         jnz       StdOut5                  ; je tich md

StdOut   PROC      NEAR

         push      bx
         mov       bx,1                     ; identifiktor zazen STDOUT

StdOut1: push      ax
         push      cx
         push      dx

         mov       cx,ds:[si]               ; poet bajt k zobrazen
         mov       dx,si                    ; zatek textu k zobrazen
         inc       dx
         inc       dx
         mov       ah,40h
         int       21h                      ; zobrazen textu

         pop       dx
         pop       cx
         pop       ax
         pop       bx
StdOut5: ret

StdOut   ENDP

; *****************************************************************************
;
;                       Rozbor pkazovho dku
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        rozbor pkazovho dku (neuchovv registry, CY=chyba parametr)
; -----------------------------------------------------------------------------

Rozbor   PROC      NEAR

; ------ pprava pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       bh,0
         mov       bl,ds:[si-1]             ; dlka pkazovho dku
         and       bl,7fh
         mov       ds:[si+bx],bh            ; oznaen konce pkazovho dku

; ------ naten znaku z pkazovho dku

Rozbor1: call      RozbChr                  ; naten znaku z pkazovho dku
         je        Rozbor1                  ; mezera - vyputn
         jnc       Rozbor12
         jmp       Rozbor7                  ; konec textu
Rozbor12:cmp       al,"{"
         je        Rozbor1                  ; ignorovn znaku "{"
         cmp       al,"|"
         je        Rozbor1                  ; ignorovn znaku "|"
         cmp       al,"}"
         je        Rozbor1                  ; ignorovn znaku "}"
         cmp       al,"/"
         je        Rozbor1                  ; ignorovn znaku "/"
         cmp       al,":"
         je        Rozbor1                  ; ignorovn znaku ":"
         cmp       al,"-"
         je        Rozbor1                  ; ignorovn znaku "-"

; ------ zadn disku

         cmp       al,"A"
         jb        Rozbor2                  ; nen oznaen disku
         cmp       al,"B"
         ja        Rozbor2                  ; nen oznaen disku
         sub       al,"A"                   ; slo disku
         mov       ds:[Disk],al             ; slo disku
         call      DekTDisk                 ; pprava oznaen disku
         jmp       short Rozbor1

; ------ povel "G" - generovn paritn diskety

Rozbor2: cmp       al,"G"
         jne       Rozbor3
         or        bh,bit0                  ; pznak zadn parametru "G"
         jmp       short Rozbor1

; ------ povel "R" - obnoven pokozen diskety archivu

Rozbor3: cmp       al,"R"
         jne       Rozbor4
         or        bh,bit1                  ; pznak zadn parametru "R"
Rozbor11:jmp       short Rozbor1

; ------ povel "T" - test vech disket archivu

Rozbor4: cmp       al,"T"
         jne       Rozbor5
         or        bh,bit2                  ; pznak zadn parametru "T"
         jmp       short Rozbor11

; ------ povel "V" - verifikace diskety

Rozbor5: cmp       al,"V"
         jne       Rozbor6
         or        bh,bit3                  ; pznak zadn parametru "V"
         jmp       short Rozbor11

; ------ povel "M" - modifikace paritn diskety

Rozbor6: cmp       al,"M"
         jne       Rozbor62
         or        bh,bit4                  ; pznak zadn parametru "M"
         jmp       short Rozbor11

; ------ povel "Q" - tich md

Rozbor62:cmp       al,"Q"
         jne       Rozbor63
         or        bh,bit6                  ; pznak zadn parametru "Q"
         jmp       short Rozbor11

; ------ povel "I" - identifikan kd

Rozbor63:cmp       al,"I"
         jne       Rozbor64
         or        bh,bit5
         jmp       short Rozbor11

; ------ povel "F" - paritn disketa uloena v souboru

Rozbor64:cmp       al,"F"
         jne       Rozbor65
         call      RozbFil                  ; rozbor jmna souboru
         jc        Rozbor8                  ; chyba zadn
         or        byte ptr ds:[Param],bit0 ; pznak paritn diskety v souboru
         jmp       short Rozbor11

; ------ povel "S" - sporn md (1 pechodn soubor)

Rozbor65:cmp       al,"S"
         jne       Rozbor8
         or        bh,bit7
         jmp       short Rozbor11

; ------ test, zda byl zadn disk i povel

Rozbor7: call      DekTDisk                 ; pprava oznaen disku
         mov       al,bh
         mov       ds:[Operace],al          ; poadovan operace
         and       al,not bit6+bit7
         cmp       al,bit0
         je        Rozbor9
         cmp       al,bit1
         je        Rozbor9
         cmp       al,bit2
         je        Rozbor9
         cmp       al,bit3
         je        Rozbor9
         cmp       al,bit4
         je        Rozbor9
         cmp       al,bit5
         je        Rozbor9
Rozbor8: stc
Rozbor9: ret

Rozbor   ENDP

; -----------------------------------------------------------------------------
;        rozbor jmna souboru (CY=chyba)
; -----------------------------------------------------------------------------

RozbFil  PROC      NEAR

; ------ nalezen zatku jmna souboru

RozbFil1:call      RozbChr                  ; naten znaku
         je        RozbFil1                 ; je mezera
         jc        RozbFil9

; ------ penesen specifikace souboru

         push      ds
         pop       es
         mov       di,offset OutpFile
         cld
RozbFil2:stosb
         call      RozbChr
         ja        RozbFil2
         mov       al,0
         stosb
         sub       di,offset OutpFile

; ------ kopie do jmna pechodnho souboru pro ten

         push      si
         mov       cx,di
         mov       si,offset OutpFile
         mov       di,offset TempFilR
         push      si
         push      cx
         rep       movsb                    ; kopie jmna souboru
         pop       cx
         pop       si

; ------ zmna jmna pechodnho souboru

         dec       di                       ; nvrat na 0
         dec       di                       ; nvrat na posledn psmeno
         cmp       byte ptr ds:[di],"."
         jne       RozbFil3
         dec       di
RozbFil3:mov       al,"$"
         cmp       al,ds:[di]
         jne       RozbFil4
         mov       al,"_"
RozbFil4:mov       ds:[di],al               ; zmna jmna

; ------ kopie do jmna pechodnho souboru pro zpis

         mov       di,offset TempFilW
         rep       movsb                    ; kopie jmna souboru

; ------ zmna jmna pechodnho souboru

         dec       di                       ; nvrat na 0
         dec       di                       ; nvrat na posledn psmeno
         cmp       byte ptr ds:[di],"."
         jne       RozbFil5
         dec       di
RozbFil5:mov       al,"@"
         cmp       al,ds:[di]
         jne       RozbFil6
         mov       al,"%"
RozbFil6:mov       ds:[di],al               ; zmna jmna

         pop       si
         clc
RozbFil9:ret

RozbFil  ENDP

; -----------------------------------------------------------------------------
;        naten znaku z pkazovho dku
; -----------------------------------------------------------------------------

RozbChr  PROC      NEAR

; ------ naten znaku

         cld
         lodsb

; ------ konverze na velk psmeno

         cmp       al,"a"
         jb        RozbChr2
         cmp       al,"z"
         ja        RozbChr2
         sub       al,32

; ------ nhrada tabultoru mezerou

RozbChr2:cmp       al,9
         jne       RozbChr3
         mov       al," "

; ------ test, zda je platn znak

RozbChr3:cmp       al," "
         jae       RozbChr4
         dec       si
RozbChr4:ret

RozbChr  ENDP

; *****************************************************************************
;
;                         Obsluha pechodnho souboru
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        zaazen nov diskety do vstupnho pechodnho souboru
; -----------------------------------------------------------------------------

TempXchg PROC      NEAR

         push      ax
         push      cx
         push      si

         mov       ax,ds:[TempIdnR]
         xchg      ax,ds:[TempIdnW]
         mov       ds:[TempIdnR],ax

         mov       si,offset TempFilR
         mov       cx,128
TempXch2:mov       al,ds:[si]
         xchg      al,ds:[si+TempFilW-TempFilR]
         mov       ds:[si],al
         inc       si
         loop      TempXch2

         pop       si
         pop       cx
         pop       ax
         ret

TempXchg ENDP

; -----------------------------------------------------------------------------
;        inicializace jmna pechodnho souboru (neuchovv registry !)
; -----------------------------------------------------------------------------

TempInit PROC      NEAR

; ------ pprava implicitnho disku

         mov       ah,19h
         int       21h                      ; poskytnut aktivnho disku
         cmp       al,2                     ; je disk A: nebo B: ?
         jae       TempIni1                 ; nen disk A: ani B:
         mov       al,2                     ; implicitn je disk C:

; ------ uloen oznaen implicitnho disku

TempIni1:push      ds
         pop       es
         mov       di,offset TempFilR       ; buffer pechodnho souboru
         cld
         add       al,"A"
         mov       ah,":"
         stosw                              ; uloen oznaen disku

; ------ test verze systmu

         mov       ah,30h
         int       21h                      ; poskytnut verze systmu
         cld
         cmp       al,3                     ; minimln verze DOS 3.xx
         jb        TempIni8                 ; je nzk verze systmu

; ------ nalezen etzce jmna programu

         push      ds
         mov       ax,ds:[2ch]              ; segment prosted
         or        ax,ax
         jz        TempIni7                 ; neplatn prosted
         mov       ds,ax                    ; segment prosted
         xor       si,si
         xor       ax,ax
TempIni2:inc       si
         js        TempIni7
         cmp       ax,ds:[si-1]
         jne       TempIni2
         inc       si

; ------ kontrola potu etzc

         lodsw                              ; poet etzc
         dec       ax                       ; je 1 a vce ?
         js        TempIni7                 ; nejsou etzce

; ------ kontrola disku

         cmp       byte ptr ds:[si+1],":"   ; je zadn disk ?
         jne       TempIni4                 ; nen zadn disk
         lodsb                              ; oznaen disku
         cmp       al,"a"
         jb        TempIni3
         cmp       al,"z"
         ja        TempIni3
         sub       al,32                    ; konverze na velk psmeno
TempIni3:cmp       al,"C"                   ; minimln oznaen disku
         jb        TempIni7                 ; neplatn disk
         cmp       al,"a"
         jae       TempIni7                 ; neplatn disk
         mov       es:[di-2],al             ; oznaen disku
         inc       si                       ; peskoen znaku ":"

; ------ penos cesty

TempIni4:mov       dx,di                    ; schova konce cesty
TempIni5:lodsb                              ; naten znaku
         stosb                              ; uloen znaku
         cmp       di,offset TempFilR+110   ; maximln konec cesty
         jae       TempIni6                 ; cesta je ji pln
         cmp       al,"\"                   ; je oddlova cesty ?
         je        TempIni4                 ; oddlova cesty
         cmp       al,"/"
         je        TempIni4                 ; oddlova cesty
         cmp       al,":"
         je        TempIni4
         cmp       al,0
         jne       TempIni5

TempIni6:mov       di,dx                    ; konec cesty

; ------ pidn jmna souboru SAFEDISK.$T$

TempIni7:pop       ds

TempIni8:mov       si,offset TempFil0
         mov       cx,13
         rep       movsb                    ; penos jmna souboru

; ------ jmno souboru k zpisu

         mov       si,offset TempFilR
         sub       di,si
         mov       cx,di                    ; dlka jmna souboru
         push      si
         push      cx
         mov       di,offset TempFilW       ; soubor pro zpis
         rep       movsb
         mov       byte ptr ds:[di-2],"@"   ; jmno souboru pro zpis
         pop       cx
         pop       si

; ------ kopie do bufferu souboru SAFEDISK.REP

         mov       di,offset RepFile
         mov       dx,di
         rep       movsb                    ; penos jmna souboru
         mov       word ptr ds:[di-4],"ER"
         mov       byte ptr ds:[di-2],"P"

; ------ oteven souboru SAFEDISK.REP pro zpis

         mov       ax,3d01h
         int       21h
         jnc       TempIni9
         mov       ah,3ch
         xor       cx,cx
         int       21h
         jc        TempIniA                 ; chyba
TempIni9:mov       ds:[RepIdnt],ax          ; identifiktor souboru

; ------ nastaven ukazatele v souboru na konec

         xchg      ax,bx
         xor       cx,cx
         xor       dx,dx
         mov       ax,4202h
         int       21h                      ; nastaven ukazatele na konec

; ------ dekdovn aktulnho data

         mov       ah,2ah
         int       21h                      ; poskytnut aktulnho data
         mov       ah,0
         mov       al,dl                    ; den
         mov       di,offset DatTxt + 3
         call      DekNum                   ; dekdovn dne
         mov       di,offset DatTxt + 6
         mov       al,dh
         call      DekNum                   ; dekdovn msce
         mov       di,offset DatTxt + 11
         xchg      ax,cx
         call      DekNum                   ; dekdovn roku

; ------ dekdovn aktulnho asu

         mov       ah,2ch
         int       21h                      ; poskytnut aktulnho asu
         mov       ah,0
         mov       al,ch
         mov       di,offset DatTxt + 15
         call      DekNum                   ; dekdovn hodiny
         mov       al,cl
         mov       di,offset DatTxt + 18
         call      DekNum                   ; dekdovn minuty
         mov       al,dh
         mov       di,offset DatTxt + 21
         call      DekNum

; ------ penesen pkazovho dku

         mov       di,offset DatTxt1
         mov       si,81h                   ; zatek pkazovho dku
         mov       cl,ds:[80h]
         and       cx,7fh
         rep       movsb                    ; penos pkazovho dku
         mov       ax,0a0dh
         stosw                              ; uloen CR/LF
         sub       di,offset DatTxt+2
         mov       ds:[DatTxt],di           ; dlka textu

; ------ vstup textu

         mov       si,offset DatTxt
         call      RepOut0                  ; vstup textu

TempIniA:ret

TempInit ENDP

; -----------------------------------------------------------------------------
;        oteven pechodnho souboru
; -----------------------------------------------------------------------------

TempOpen PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx

; ------ test, zda je soubor pro ten ji vytvoen

         cmp       word ptr ds:[TempIdnR],0 ; je soubor ji vytvoen ?
         jne       TempOpn4                 ; soubor je ji vytvoen

; ------ oteven vstupnho souboru

         test      byte ptr ds:[Param],bit0 ; paritn disketa v souboru ?
         jz        TempOpn2                 ; nen disketa v souboru
         mov       dx,offset OutpFile
         mov       ax,3d00h
         int       21h                      ; oteven souboru pro ten
         jc        TempOpn2
         mov       ds:[OutpIdnt],ax         ; identifiktor souboru

; ------ vytvoen souboru pro ten

TempOpn2:mov       dx,offset TempFilR       ; jmno souboru pro ten
         mov       ah,3ch
         xor       cx,cx                    ; CX <- 0 atributy
         int       21h                      ; vytvoen souboru
         jnc       TempOpn3                 ; soubor vytvoen OK

; ------ chyba - soubor nelze vytvoit

TempOp22:mov       si,offset ErrOTxt
         jmp       Chyba

; ------ uloen identifiktoru pro ten

TempOpn3:mov       ds:[TempIdnR],ax         ; identifiktor souboru

; ------ test, zda je soubor pro zpis ji vytvoen

TempOpn4:cmp       word ptr ds:[TempIdnW],0 ; je soubor pro zpis ji vytvoen ?
         jne       TempOpn9                 ; je ji vytvoen
         mov       ax,ds:[TempIdnR]         ; soubor pro ten
         test      byte ptr ds:[Operace],bit7 ; je sporn md ?
         jnz       TempOpn8                 ; je sporn md

; ------ vytvoen souboru

         mov       dx,offset TempFilW       ; jmno souboru pro zpis
         mov       ah,3ch
         xor       cx,cx                    ; CX <- 0 atributy
         int       21h                      ; vytvoen souboru
         jc        TempOp22                 ; chyba vytvoen souboru

; ------ uloen identifiktoru

TempOpn8:mov       ds:[TempIdnW],ax         ; identifiktor souboru pro zpis

; ------ nvrat registr

TempOpn9:pop       dx
         pop       cx
         pop       ax
         ret

TempOpen ENDP

; -----------------------------------------------------------------------------
;        uzaven a zruen pechodnho souboru
; -----------------------------------------------------------------------------

TempClos PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx

; ------ test, zda je soubor pro ten vytvoen

         mov       bx,ds:[TempIdnR]         ; identifiktor souboru pro ten
         or        bx,bx                    ; je soubor vytvoen ?
         jz        TempCls4                 ; soubor nen vytvoen

; ------ uzaven souboru

         mov       ah,3eh
         int       21h                      ; uzaven souboru
         mov       word ptr ds:[TempIdnR],0 ; zruen identifiktoru
         test      byte ptr ds:[Operace],bit7
         jz        TempCls2
         mov       word ptr ds:[TempIdnW],0

; ------ zruen souboru

TempCls2:mov       dx,offset TempFilR       ; jmno souboru
         mov       ah,41h
         int       21h                      ; zruen pechodnho souboru

; ------ uzaven vstupnho souboru

TempCls4:mov       bx,ds:[OutpIdnt]
         or        bx,bx
         jz        TempCls5
         mov       ah,3eh
         int       21h                      ; uzaven souboru
         mov       word ptr ds:[OutpIdnt],0 ; zruen identifiktoru

; ------ test, zda je soubor pro zpis vytvoen

TempCls5:test      byte ptr ds:[Operace],bit7 ; je sporn md ?
         jnz       TempCls9                 ; je sporn md
         mov       bx,ds:[TempIdnW]         ; identifiktor souboru pro zpis
         or        bx,bx                    ; je soubor vytvoen ?
         jz        TempCls9                 ; soubor nen vytvoen

; ------ uzaven souboru

         mov       ah,3eh
         int       21h                      ; uzaven souboru
         mov       word ptr ds:[TempIdnW],0 ; zruen identifiktoru

; ------ zruen souboru

         mov       dx,offset TempFilW       ; jmno souboru
         mov       ah,41h
         int       21h                      ; zruen pechodnho souboru

; ------ nvrat registr

TempCls9:pop       dx
         pop       bx
         pop       ax
         ret

TempClos ENDP

; -----------------------------------------------------------------------------
;        zpis paritn diskety do souboru (neuchovv registry)
; -----------------------------------------------------------------------------

ZapOutp  PROC      NEAR

; ------ uzaven pechodnho souboru

         mov       bx,ds:[TempIdnR]
         or        bx,bx
         jz        ZapOutp2
         mov       ah,3eh
         int       21h
         jc        ZapOutp6
         mov       word ptr ds:[TempIdnR],0
         test      byte ptr ds:[Operace],bit7
         jz        ZapOutp2
         mov       word ptr ds:[TempIdnW],0

; ------ uzaven starho souboru

ZapOutp2:mov       bx,ds:[OutpIdnt]         ; identifiktor souboru
         or        bx,bx
         jz        ZapOutp3
         mov       ah,3eh
         int       21h                      ; uzaven souboru
         jc        ZapOutp6
         mov       word ptr ds:[OutpIdnt],0

; ------ zruen starho souboru

         mov       dx,offset OutpFile
         mov       ah,41h
         int       21h                      ; zruen starho souboru
         jc        ZapOutp6

; ------ pejmenovn souboru

ZapOutp3:push      ds
         pop       es
         mov       dx,offset TempFilR       ; pvodn soubor
         mov       di,offset OutpFile       ; nov jmno
         mov       ah,56h
         int       21h                      ; pejmenovn souboru
         jnc       ZapOutp7

; ------ chyba zpisu

ZapOutp6:mov       si,offset ErrOWTxt
         jmp       Chyba

; ------ oteven vstupnho souboru pro ten

ZapOutp7:mov       dx,offset OutpFile       ; vstupn soubor
         mov       ax,3d00h
         int       21h                      ; oteven pro ten
         jc        ZapOutp6
         xchg      ax,bx                    ; BX <- identifiktor

; ------ uren velikosti bufferu

         mov       cx,ds:[BuffMax]          ; velikost bufferu
         cmp       cx,120
         jb        ZapOut72
         mov       cx,120
ZapOut72:mov       ch,cl
         mov       cl,0
         shl       cx,1                     ; max. velikost
         mov       word ptr ds:[EDC],-1

; ------ naten bloku dat ze souboru

ZapOut74:push      ds
         mov       ds,ds:[BuffDat]          ; datov buffer
         xor       dx,dx
         mov       ah,3fh
         int       21h                      ; naten bloku dat
         pop       ds
         jc        ZapOutp6

; ------ pepoet dat na sektory

         mov       al,ah
         shr       al,1                     ; poet sektor
         jz        ZapOut78                 ; nejsou dal data

; ------ kontroln souet bloku dat

         push      bx
         mov       dx,ds:[EDC]
         mov       es,ds:[BuffDat]
         xor       bx,bx
         call      CheckSum
         mov       ds:[EDC],dx
         pop       bx
         jmp       short ZapOut74           ; dal blok dat

; ------ uzaven souboru

ZapOut78:mov       ah,3eh
         int       21h

; ------ zobrazen hlen o operaci

         mov       ax,word ptr ds:[PartTxt1]
         mov       word ptr ds:[EDCITxt3],ax
         mov       ax,word ptr ds:[PartTxt1+2]
         mov       word ptr ds:[EDCITxt3+2],ax

         inc       word ptr ds:[NDisket]    ; zven sla diskety
         call      DekNDisk                 ; dekdovn sla diskety
         call      DispEDC                  ; zobrazen kontrolnho soutu
         ret

ZapOutp  ENDP

; -----------------------------------------------------------------------------
;        resetovn ukazatele v pechodnm souboru
; -----------------------------------------------------------------------------

TempRes  PROC      NEAR

         push      ax
         xor       ax,ax
         mov       word ptr ds:[ReadUTmp],ax
         mov       word ptr ds:[ReadUTmp+2],ax
         mov       word ptr ds:[WritUTmp],ax
         mov       word ptr ds:[WritUTmp+2],ax
         pop       ax
         ret

TempRes  ENDP

; -----------------------------------------------------------------------------
;        zpis dat z bufferu do pechodnho souboru
; -----------------------------------------------------------------------------

TempWrit PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      bp

; ------ nastaven ukazatele v souboru

         mov       bx,ds:[TempIdnW]         ; identifiktor souboru
         or        bx,bx                    ; je soubor oteven ?
         jz        TempWrt9                 ; nen oteven

         mov       ax,4200h
         mov       dx,word ptr ds:[WritUTmp] ; zpisov offset
         mov       cx,word ptr ds:[WritUTmp+2]
         int       21h                      ; nastaven ukazatele v souboru
         jc        TempWrt4                 ; njak chyba

; ------ pprava ukazatel k operaci

         mov       bp,ds:[BuffUkaz]         ; ukazatel adresy v bufferu
         mov       dx,ds:[BuffDat]          ; zatek bufferu
         mov       ds:[BuffUkaz],dx         ; nov ukldac adresa
         sub       bp,dx                    ; poet dat k uloen
         jbe       TempWrt9                 ; nejsou dn data k uloen

; ------ velikost bloku dat pro jednu operaci

TempWrt2:mov       cx,120*512/16            ; asi tak velikost jednoho bloku
         cmp       cx,bp
         jb        TempWrt3
         mov       cx,bp                    ; omezen velikosti dat
TempWrt3:sub       bp,cx                    ; snen tae zbylch dat
         shl       cx,1
         shl       cx,1
         shl       cx,1
         shl       cx,1                     ; pepoet na bajty

; ------ zpis jednoho bloku dat do souboru

         push      dx
         push      ds
         mov       ds,dx                    ; segment adresy bufferu
         xor       dx,dx                    ; offset adresy bufferu
         mov       ah,40h
         int       21h                      ; zpis dat do souboru
         pop       ds
         pop       dx

; ------ chyba zpisu do souboru

         jc        TempWrt4                 ; chyba zpisu
         cmp       ax,cx                    ; bylo zapsno ve ?
         je        TempWrt5                 ; je zapsno ve OK
         mov       si,offset ErrTWDTx       ; nedostatek msta na disku
         jmp       short TempWr42
TempWrt4:mov       si,offset ErrTWTxt
TempWr42:call      MazText                  ; vymazn dku
         jmp       Chyba

; ------ pprava pro dal blok dat

TempWrt5:add       word ptr ds:[WritUTmp],cx ; zven ukazatele v souboru
         adc       word ptr ds:[WritUTmp+2],0
         add       dx,120*512/16            ; zven adresy bufferu
         or        bp,bp                    ; je dal msto ?
         jnz       TempWrt2                 ; naten dalho bloku dat

; ------ nvrat registr

TempWrt9:mov       word ptr ds:[BuffCit],0  ; nezbyly dn sektory
         pop       bp
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

TempWrit ENDP

; -----------------------------------------------------------------------------
;        naten bufferu z pechodnho souboru
; -----------------------------------------------------------------------------

TempRead PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      di
         push      bp
         push      es

; ------ pprava k naten dat ze souboru

         mov       dx,ds:[BuffDat]          ; zatek datovho bufferu
         mov       bp,ds:[BuffMax]          ; maximln poet sektor k naten
         mov       ds:[BuffCit],bp          ; ta zbylch sektor v bufferu
         mov       ds:[BuffUkaz],dx         ; ukazatel adresy v bufferu

; ------ test, zda je pechodn soubor oteven

         mov       bx,ds:[TempIdnR]         ; identifiktor souboru
         or        bx,bx
         jz        TempRea9                 ; soubor nen oteven

; ------ nastaven ukazatele v souboru

         push      dx
         mov       ax,4200h
         mov       dx,word ptr ds:[ReadUTmp] ; tec offset
         mov       cx,word ptr ds:[ReadUTmp+2]
         int       21h                      ; nastaven ukazatele v souboru
         pop       dx
         jc        TempRea4                 ; njak chyba

; ------ stanoven potu sektor pro jednu operaci

TempRea2:mov       cx,120                   ; asi tak maximum pro jednu operaci
         cmp       cx,bp
         jb        TempRea3
         mov       cx,bp                    ; omezen potu sektor
TempRea3:sub       bp,cx                    ; snen zbylho potu sektor

; ------ inicializan vymazn bufferu

         mov       ch,cl                    ; CH <- poet sektor
         mov       cl,0
         push      cx                       ; poet slov
         xor       ax,ax
         xor       di,di
         mov       es,dx                    ; adresa bufferu
         cld
         rep       stosw                    ; vymazn bufferu
         pop       cx
         shl       cx,1                     ; poet bajt k naten

; ------ naten bloku dat

         push      dx
         push      ds
         mov       ds,dx                    ; adresa bufferu
         xor       dx,dx                    ; offset bufferu
         mov       ah,3fh
         int       21h                      ; naten bloku dat
         pop       ds
         pop       dx
         jnc       TempRea5                 ; operace ten OK

; ------ chyba ten ze souboru

TempRea4:mov       si,offset ErrTRTxt
         jmp       Chyba

; ------ pprava pro dal blok dat

TempRea5:add       word ptr ds:[ReadUTmp],cx ; zven ukazatele v souboru
         adc       word ptr ds:[ReadUTmp+2],0
         add       dx,120*512/16            ; zven adresy bufferu
         or        bp,bp                    ; je dal msto ?
         jnz       TempRea2                 ; naten dalho bloku dat

; ------ nvrat registr

TempRea9:pop       es
         pop       bp
         pop       di
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

TempRead ENDP

; -----------------------------------------------------------------------------
;        naten stopy z pechodnho souboru
; -----------------------------------------------------------------------------

ReadTTrc PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ kopie jednoho sektoru

         mov       dh,0
         mov       dl,ds:[NumSekt]          ; poet sektor na stopu
         mov       es,ds:[BuffDisk]         ; buffer stopy
         xor       di,di                    ; ukldac adresa do bufferu
ReadTTr2:xor       si,si
         push      ds
         mov       ds,ds:[BuffUkaz]         ; ukazatel v bufferu
         mov       cx,512/2                 ; dlka jednoho sektoru
         cld
         rep       movsw                    ; kopie sektoru
         pop       ds

; ------ posun ukazatele k dalmu sektoru

         add       word ptr ds:[BuffUkaz],512/16 ; zven ukazatele v bufferu
         dec       word ptr ds:[BuffCit]    ; snen tae zbylch sektor
         jnz       ReadTTr4                 ; jsou dal sektory
         call      TempRead                 ; naten dalho bloku dat
ReadTTr4:dec       dx                       ; ta sektor
         jnz       ReadTTr2                 ; dal sektor

; ------ nvrat registr

         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

ReadTTrc ENDP

; *****************************************************************************
;
;                                 Rzn
;
; *****************************************************************************
;
; -----------------------------------------------------------------------------
;        zmna disku, je-li klvesa "M" (CY=nebyla klvesa "M")
; -----------------------------------------------------------------------------

XchgDsk  PROC      NEAR

         cmp       al,"M"                   ; je klvesa "M" ?
         je        XchgDsk2
         stc
         ret

XchgDsk2:xor       byte ptr ds:[Disk],1     ; zmna disku
         test      byte ptr ds:[Operace],bit5 ; je identifikace disket ?
         jz        DekTDisk                 ; nen identifikace

         push      ax
         push      cx
         push      dx

         mov       al,ds:[Disk]             ; slo disku
         mov       cl,al                    ; slo disku
         mov       ah,10h
         shl       ah,cl                    ; rotace bitu pro zapnut motoru
         or        al,ah
         or        al,4                     ; adi uvolnn, nen peruen
         mov       dx,3f2h
         out       dx,al                    ; pepnut motor

         pop       dx
         pop       cx
         pop       ax
                                            ; pokrauje dekdovn oznaen !
XchgDsk  ENDP

; -----------------------------------------------------------------------------
;        dekdovn oznaen disku (mus nsledovat za XchgDsk !)
; -----------------------------------------------------------------------------

DekTDisk PROC      NEAR

         push      ax
         mov       al,ds:[Disk]
         add       al,"A"
         mov       ds:[DiskChr1],al         ; oznaen mechaniky
         mov       ds:[DiskChr2],al
         mov       ds:[DiskChr3],al
         mov       ds:[DiskChr4],al
         mov       ds:[DiskChr5],al
         mov       ds:[DiskChr6],al
         mov       ds:[DiskChr7],al
         mov       ds:[DiskChr8],al
         mov       ds:[DiskChr9],al
         mov       ds:[DiskChrA],al
         pop       ax
         clc
         ret

DekTDisk ENDP

; -----------------------------------------------------------------------------
;        dekdovn velikosti disku
; -----------------------------------------------------------------------------

DekFDsk  PROC      NEAR

         push      di
         mov       di,offset DFormT1
         call      DekFDsk0
         mov       di,offset DFormT2
         call      DekFDsk0
         mov       di,offset DFormT3
         call      DekFDsk0
         mov       di,offset DFormT4
         call      DekFDsk0
         pop       di
         ret

DekFDsk  ENDP

DekFDsk0 PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      es

; ------ pprava registr

         push      ds
         pop       es
         mov       ax,ds:[CelkSkt0]         ; celkem sektor
         shr       ax,1                     ; kapacita v KB
         mov       word ptr ds:[di],"  "
         mov       word ptr ds:[di+2],"  "

; ------ dekdovn kapacity pro kapacitu < 1 MB

         cmp       ax,1000
         jae       DekFDsk2                 ; je vce ne 1 MB
         inc       di
         inc       di
         mov       byte ptr ds:[di+2],"K"   ; daj v KB
         call      DekNum                   ; dekdovn sla kapacity
         jmp       short DekFDsk8

; ------ dekdovn kapacity v MB

DekFDsk2:mov       byte ptr ds:[di+4],"M"   ; daj v MB
         xor       dx,dx
         mov       cx,1000
         div       cx                       ; poet MB
         add       al,"0"
         cld
         mov       ah,"."
         stosw                              ; slice MB a teka
         mov       al,"0"
         stosb
         xor       ax,ax
         xchg      ax,dx                    ; desetiny
         mov       cx,10
         div       cx                       ; stovky
         call      DekNum                   ; dekdovn destek KB
         cmp       byte ptr ds:[di],"0"
         jne       DekFDsk8
         mov       byte ptr ds:[di]," "

; ------ nvrat registr

DekFDsk8:pop       es
         pop       dx
         pop       cx
         pop       ax
         ret

DekFDsk0 ENDP

; -----------------------------------------------------------------------------
;        dekdovn sla diskety
; -----------------------------------------------------------------------------

DekNDisk PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      di
         push      es

; ------ pprava registr

         push      ds
         pop       es                       ; ES <- datov segment
         mov       ax,ds:[NDisket]          ; slo diskety
         xor       dx,dx
         mov       cx,1000                  ; omezen velikosti sla
         div       cx
         xchg      ax,dx                    ; AX <- slo diskety (zarovnan)

; ------ dekdovn sla diskety

         mov       di,offset IdntTx21 + 2
         call      DekNum
         mov       di,offset NactTxt2 + 2
         call      DekNum

; ------ nvrat registr

         pop       es
         pop       di
         pop       dx
         pop       cx
         pop       ax
         ret

DekNDisk ENDP

; -----------------------------------------------------------------------------
;        dekdovn sla AX do bufferu ES:DI zptn
; -----------------------------------------------------------------------------

DekNum   PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      di

; ------ dekdovn sla

         mov       cx,10
DekNum1: xor       dx,dx
         div       cx                       ; vpoet slice
         add       dl,"0"                   ; slice
         mov       es:[di],dl
         dec       di
         or        ax,ax                    ; je slo ji = 0 ?
         jnz       DekNum1                  ; dal slice

; ------ nvrat registr

         pop       di
         pop       dx
         pop       cx
         pop       ax
         ret

DekNum   ENDP

; -----------------------------------------------------------------------------
;        dekdovn identifikanho kdu diskety
; -----------------------------------------------------------------------------

DekEDCI  PROC      NEAR

         push      ax
         push      di
         push      es

         push      ds
         pop       es
         mov       ax,ds:[EDCIdent]         ; identifikan kd diskety
         mov       di,offset CtuTxt4
         call      HexWord
         mov       di,offset ZapTxt4
         call      HexWord
         mov       di,offset EDCITxt2
         call      HexWord
         mov       di,offset EDCITxt3
         call      HexWord

         pop       es
         pop       di
         pop       ax
         ret

DekEDCI  ENDP

; -----------------------------------------------------------------------------
;        dekdovn identifikanho kdu paritn diskety
; -----------------------------------------------------------------------------

DekEDCP  PROC      NEAR

         push      ax
         push      di
         push      es

         push      ds
         pop       es
         mov       ax,ds:[EDCParit]         ; identifikan kd diskety
         mov       di,offset PartTxt1
         call      HexWord
         mov       di,offset VystTxt1
         call      HexWord
         mov       di,offset ZapTxt4
         call      HexWord
         mov       di,offset GenTxt22
         call      HexWord

         pop       es
         pop       di
         pop       ax
         ret

DekEDCP  ENDP

; -----------------------------------------------------------------------------
;        zobrazen kontrolnho soutu
; -----------------------------------------------------------------------------

DispEDC  PROC      NEAR

; ------ schova registr

         push      ax
         push      si
         push      di
         push      es

; ------ dekdovn kontrolnho soutu

         push      ds
         pop       es
         mov       di,offset EDCTxt
         mov       ax,ds:[EDC]              ; kontroln souet diskety
         call      HexWord                  ; dekdovn slova HEX

; ------ zobrazen hlen

         mov       si,offset NactTxt
         call      StdOut
         call      RepOut                   ; vstup do protokolu

; ------ nvrat registr

         pop       es
         pop       di
         pop       si
         pop       ax
         ret

DispEDC  ENDP

; -----------------------------------------------------------------------------
;        dekdovn slova HEX (AX) do bufferu ES:DI
; -----------------------------------------------------------------------------

HexWord  PROC      NEAR

         xchg      al,ah
         call      HexByte                  ; dekdovn bajtu HEX
         xchg      al,ah

HexByte: push      ax
         shr       al,1
         shr       al,1
         shr       al,1
         shr       al,1
         call      HexChr
         pop       ax

HexChr:  push      ax
         and       al,0fh                   ; znak
         cmp       al,9
         jbe       HexChr2
         add       al,7
HexChr2: add       al,"0"
         cld
         stosb
         pop       ax
         ret

HexWord  ENDP

; -----------------------------------------------------------------------------
;        identifikan kd diskety (natena stopa 0, strana 0)
; -----------------------------------------------------------------------------

SumEDCI  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx
         push      es

; ------ identifikan kd

         mov       es,ds:[BuffDisk]         ; buffer stopy
         xor       bx,bx                    ; offset stopy
         mov       al,ds:[NumSekt]          ; poet sektor
         mov       dx,-1                    ; identifikan kd diskety
         call      CheckSum                 ; kontroln souet stopy
         mov       ds:[EDCIdent],dx         ; identifikan kd diskety
         call      DekEDCI                  ; dekdovn identifikanho kdu

; ------ nvrat registr

         pop       es
         pop       dx
         pop       bx
         pop       ax
         ret

SumEDCI  ENDP

; -----------------------------------------------------------------------------
;        identifikan kd paritn diskety (natena stopa 0, strana 0)
; -----------------------------------------------------------------------------

SumEDCP  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      dx
         push      es

; ------ identifikan kd

         mov       es,ds:[BuffDat]          ; buffer stopy
         xor       bx,bx                    ; offset stopy
         mov       al,ds:[NumSekt]          ; poet sektor
         mov       dx,-1                    ; identifikan kd diskety
         call      CheckSum                 ; kontroln souet stopy
         mov       ds:[EDCParit],dx         ; identifikan kd par. diskety
         call      DekEDCP                  ; dekdovn identifikanho kdu

; ------ nvrat registr

         pop       es
         pop       dx
         pop       bx
         pop       ax
         ret

SumEDCP  ENDP

; -----------------------------------------------------------------------------
;        kontroln souet EDC cel stopy
; -----------------------------------------------------------------------------

CheckSm0 PROC      NEAR

         push      ax
         push      bx
         push      dx
         push      es

         mov       dx,ds:[EDC]              ; star hodnota EDC
         xor       bx,bx                    ; potek dat
         mov       es,ds:[BuffDisk]         ; buffer naten stopy
         mov       al,ds:[NumSekt]          ; poet sektor na stopu
         call      CheckSum                 ; kontroln souet dat
         mov       ds:[EDC],dx              ; vstupn hodnota EDC

         pop       es
         pop       dx
         pop       bx
         pop       ax
         ret

CheckSm0 ENDP

; -----------------------------------------------------------------------------
;        Kontroln souet EDC dat ES:BX (AL sektor) z DX -> DX
; -----------------------------------------------------------------------------

CheckSum PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      si
         push      di

; ------ pprava registr

         mov       ah,al                    ; AH <- poet sektor
         mov       al,0
         shl       ax,1                     ; poet bajt v bufferu
         xchg      ax,di                    ; DI <- poet bajt
         mov       si,bx                    ; SI <- adresa dat
         cld                                ; smr nahoru

; ------ kontroln souet dat

         push      ds
         push      es
         pop       ds

CheckSm1:lodsb                              ; a = fgetc(fp);
         xor       al,dh                    ; d = a ^= d;
         mov       dh,al
         mov       cl,4
         shr       al,cl                    ; a >>= 4;
         xor       al,dh                    ; d = a ^= d;
         mov       dh,al
         mov       cl,3
         ror       al,cl                    ; a = (a >> 3) | (a << 5);
         mov       ch,al                    ; f = a;
         and       al,1fh                   ; a &= 0x1f;
         xor       al,dl                    ; e = a ^= e;
         mov       dl,al
         mov       al,ch                    ; a = f;
         ror       al,1                     ; a = (a >> 1) | (a << 7);
         and       al,0f0h                  ; a &= 0xf0;
         xor       al,dl                    ; e = a ^= e;
         mov       dl,al
         mov       al,ch                    ; a = f & 0xe0;
         and       al,0e0h
         xor       al,dh                    ; a ^= d;
         mov       dh,dl                    ; d = e;
         mov       dl,al                    ; e = a;

         dec       di
         jnz       CheckSm1                 ; dal bajt
         pop       ds

; ------ nvrat registr

         pop       di
         pop       si
         pop       cx
         pop       ax
         ret

CheckSum ENDP

; -----------------------------------------------------------------------------
;        test, zda je peruen operace (CY=je peruen)
; -----------------------------------------------------------------------------

TstBreak PROC      NEAR

         test      byte ptr ds:[Param],bit7 ; je peruen ?
         jz        TstBrea2                 ; nen peruen
         stc                                ; pznak peruen operace
TstBrea2:ret

TstBreak ENDP

; -----------------------------------------------------------------------------
;        nulovn pznaku peruen
; -----------------------------------------------------------------------------

NulBreak PROC      NEAR

         and       byte ptr ds:[Param],not bit7
         ret

NulBreak ENDP

; -----------------------------------------------------------------------------
;        nastaven pznaku peruen (nastavuje pznak CY !)
; -----------------------------------------------------------------------------

SetBreak PROC      NEAR

         or        byte ptr ds:[Param],bit7
         stc                                ; pznak peruen
         ret

SetBreak ENDP

; *****************************************************************************
;
;                             Data
;
; *****************************************************************************
;
Operace  db        0                        ; provdn operace
                                            ;   bit 0: 1=gener. paritn diskety
                                            ;   bit 1: 1=obnoven arch. diskety
                                            ;   bit 2: 1=test vech disket
                                            ;   bit 3: 1=verifikace diskety
                                            ;   bit 4: 1=modifikace paritn diskety
                                            ;   bit 5: 1=zobrazen ident. kdu
                                            ;   bit 6: 1=tich md
                                            ;   bit 7: 1=sporn md (1 soubor)

Param    db        0                        ; parametry
                                            ;   bit 0: 1=paritn disketa v souboru
                                            ;   bit 1: 1=dopluje se obn. disk
                                            ;   bit 2: 1=uren paritn disketa
                                            ;   bit 3: 1=nekompatibiln BOOT
                                            ;   bit 4: 1=je paritn disketa
                                            ;   bit 5: 1=byla ji prvn disketa
                                            ;   bit 6: 1=pedefinovno INT 1Eh
                                            ;   bit 7: 1=je peruen operace

EDC      dw        -1                       ; stada kontrolnho soutu diskety
EDCIdent dw        -1                       ; identifikan CRC diskety
EDCParit dw        -1                       ; identifikan CRC paritn diskety

AktHlas  dw        InitTxt                  ; adresa aktulnho hlen diskety

NDisket  dw        0                        ; ta sla disket

UspechS  dw        0                        ; ta nulovch sektor pi testu

; ------ buffery

BuffBeg  dw        0                        ; adresa zatku bufferu

BuffDisk dw        0                        ; adresa bufferu pracovn stopy
BuffDskV dw        0                        ; adresa bufferu verifikovan stopy

BuffDat  dw        0                        ; zatek datovho bufferu
BuffUkaz dw        0                        ; ukazatel adresy v bufferu
BuffCit  dw        0                        ; ta zbylch sektor v bufferu
BuffMax  dw        0                        ; maximln poet sektor v bufferu

; ------ parametry diskety

Disk     db        0                        ; slo disku

NumStop  db        40                       ; poet stop
NumStran db        2                        ; poet stran
NumSekt  db        9                        ; poet sektor na stopu
CelkSekt dw        9*2*40                   ; celkem sektor na disku

NumStop0 db        40                       ; poet stop (naten)
NumStrn0 db        2                        ; poet stran (naten)
NumSekt0 db        9                        ; poet sektor na stopu (naten)
CelkSkt0 dw        9*2*40                   ; celkem sektor na disku (naten)

; ------ pechodn soubor

RepIdnt  dw        0                        ; identifiktor souboru hlen
OutpIdnt dw        0                        ; identifiktor vstupnho souboru
TempIdnR dw        0                        ; pechodn soubor pro ten (zpis)
TempIdnW dw        0                        ; pechodn soubor pro zpis

TempFil0 db        'SAFEDISK.$T$',0         ; pechodn soubor pro ten (zpis)
                                            ;  pro ten koncov znak $ pop. _
                                            ;  pro zpis ppona @ pop. %

ReadUTmp dd        0                        ; tec ukazatel pechodnho souboru
WritUTmp dd        0                        ; zpisov ukazatel pechod. souboru

; ------ texty

UvTxt    dw        UvTxt0-UvTxt-2
         db        'SAFEDISK V1.00 - zabezpeceni archivnich disket; (c) Miroslav Nemecek',13,10
UvTxt0   label     byte

HelpTxt  dw        HelpTxt0-HelpTxt-2
         db        13,10
         db        'Zadejte:  SAFEDISK  [ A: | B: ] { G | R | M | T | V | I } [ Q ] [ F soubor ]',13,10
         db        '           A: (B:) .... operace se provadi v mechanice A: (B:)',13,10
         db        '           G .......... vygenerovani zabezpecovaci paritni diskety',13,10
         db        '           R .......... obnoveni poskozene diskety archivu',13,10
         db        '           M .......... modifikace paritni diskety (pridani/vypusteni diskety)',13,10
         db        '           T .......... test celistvosti skupiny disket archivu',13,10
         db        '           V .......... verifikace a kontrolni soucet diskety',13,10
         db        '           I .......... zobrazeni identifikacniho kodu diskety',13,10
         db        '           Q .......... tichy mod, potlaceni zobrazeni napovedy',13,10
         db        '           S .......... usporny mod (mene bezpecny - 1 prechodny soubor)',13,10
         db        '           F soubor ... paritni disketa ulozena v zadanem souboru',13,10
         db        13,10
         db        '     Program  SAFEDISK zabezpecuje diskety archivu vygenerovanim paritni',13,10
         db        '     zabezpecovaci  diskety.  Paritni disketa je bitovou logickou funkci',13,10
         db        '     XOR  vsech  disket  archivu. Po vzniku chyby na kterekoliv z disket',13,10
         db        '     (nebo i vice disketach soucasne) lze poskozenou disketu opet zpetne',13,10
         db        '     vygenerovat pomoci paritni diskety a vsech zbyvajicich disket.',13,10
         db        '     Do souboru SAFEDISK.REP se zapisuje protokol o vsech operacich.',13,10
         db        13,10
HelpTxt0 label     byte

PrerTxt  dw        PrerTxt0-PrerTxt-2
         db        '*PRERUSENO*',13,10
PrerTxt0 label     byte

Help2Txt dw        Help2Tx0-Help2Txt-2
         db        'Chyba zadani parametru !',13,10
Help2Tx0 label     byte

MemTxt   dw        MemTxt0-MemTxt-2
         db        'CHYBA - nedostatek pameti !',13,10
MemTxt0  label     byte

DatTxt   dw        DatTxt1-DatTxt-2
         db        ' 0.00.   0   0:00:00 '
DatTxt1  db        130 dup(0)

DatTxt0  dw        5
         db        5 dup(" ")

; ------ generovn paritn diskety

GenTxt   dw        GenTxt0-GenTxt-2
         db        'Ŀ',13,10
         db        '            GENEROVANI zabezpecovaci paritni diskety              ',13,10
         db        'Ĵ',13,10
         db        ' Vkladejte postupne jednotlive diskety skupiny archivnich disket, ',13,10
         db        ' ktere chcete  zabezpecit  paritni  disketou.  Na  poradi a poctu ',13,10
         db        ' disket  nezalezi,  ale  dobre  si zaevidujte, ktere diskety tato ',13,10
         db        ' paritni disketa zabezpecuje (nejlepe na stitek paritni diskety), ',13,10
         db        ' jinak  nebude  obnoveni  disket  mozne. Je vhodne poznacit si na ',13,10
         db        ' diskety i jejich kontrolni soucty pro pozdejsi kontrolu  disket. ',13,10
         db        ' Pozor  -  vsechny  diskety  musi  mit stejny format (velikost) ! ',13,10
         db        ' Po vlozeni vsech disket skupiny  archivu zadejte povel "(Z)apis" ',13,10
         db        ' (kod za timto povelem je identifikacni kod paritni diskety).     ',13,10
         db        '',13,10
GenTxt0  label     byte

GenMnu1  db        3
         db        'D',27
         db        'M',36
         db        'P',49

GenTxt1  dw        GenTxt10-GenTxt1-2
         db        13,'Vlozte disketu do '
DiskChr1 db        'A: ... (D)alsi, (M)echanika, (P)reruseni'
GenTxt10 label     byte

GenMnu2  db        4
         db        'D',27
         db        'Z',36
         db        'M',56
         db        'P',69

GenTxt2  dw        GenTxt20-GenTxt2-2
         db        13,'Vlozte disketu do '
DiskChr8 db        'A: ... (D)alsi, (Z)apis (kod='
GenTxt22 db        'FFFF), (M)echanika, (P)reruseni'
GenTxt20 label     byte

PartMnu  db        3
         db        'Z',46
         db        'N',55
         db        'P',65

PartTxt  dw        PartTxt0-PartTxt-2
         db        13,'Bude zapsana PARITNI disketa (kod='
PartTxt1 db        'FFFF) ... (Z)apis, (N)avrat, (P)reruseni'
PartTxt0 label     byte

ParitTxt dw        ParitTx0-ParitTxt-2
         db        13,10
         db        'Paritni disketa vygenerovana. Upozorneni - paritni disketu',13,10
         db        'nelze pouzit v systemu DOS (oznacuje disketu jako vadnou).',13,10
ParitTx0 label     byte

; ------ obnoven diskety

ObnTxt   dw        ObnTxt0-ObnTxt-2
         db        'Ŀ',13,10
         db        '                    OBNOVENI poskozene diskety                      ',13,10
         db        'Ĵ',13,10
         db        ' K obnoveni poskozene diskety ze skupiny disket potrebujete paritni ',13,10
         db        ' disketu,  kterou  byla  tato skupina zabezpecena a vsechny ostatni ',13,10
         db        ' diskety  ze skupiny. Postupne vkladejte nejdrive paritni disketu a ',13,10
         db        ' potom  vsechny  ostatni  diskety. Na zaver zvolte povel "(Z)apis", ',13,10
         db        ' ktery  vygeneruje  novou  opravovanou  disketu  (kod za povelem je ',13,10
         db        ' identifikacni kod teto diskety).                                   ',13,10
         db        '                                                                    ',13,10
         db        ' Pozn.: Pokud se behem operace objevila chyba na nektere z disket,  ',13,10
         db        '        obnovi se chybejici cast dat z puvodni poskozene diskety !  ',13,10
         db        '',13,10
ObnTxt0  label     byte

ObnMnu1  db        3
         db        'D',35
         db        'M',43
         db        'P',56

ObnTxt1  dw        ObnTxt10-ObnTxt1-2
         db        13,'Vlozte PARITNI disketu do '
DiskChr7 db        'A: ... (D)ale, (M)echanika, (P)reruseni'
ObnTxt10 label     byte

VystMnu  db        3
         db        'Z',47
         db        'M',56
         db        'P',69

VystTxt  dw        VystTxt0-VystTxt-2
         db        13,'Bude zapsana OBNOVENA disketa (kod='
VystTxt1 db        'FFFF) ... (Z)apis, (M)echanika, (P)reruseni'
VystTxt0 label     byte

OprvMnu  db        3
         db        'D',41
         db        'Z',49
         db        'P',58

OprvTxt  dw        OprvTxt0-OprvTxt-2
         db        13
         db        'Vlozte OBNOVOVANOU disketu k doplneni: (D)ale, (Z)apis, (P)rerusit'
OprvTxt0 label     byte

; ------ modifikace paritn diskety

ModTxt   dw        ModTxt0-ModTxt-2
         db        'Ŀ',13,10
         db        '                     MODIFIKACE paritni diskety                       ',13,10
         db        'Ĵ',13,10
         db        ' Tuto  funkci  pouzijte  v pripade, ze chcete pridat dalsi disketu ke ',13,10
         db        ' skupine  archivnich  disket nebo ze chcete nekterou disketu vypustit ',13,10
         db        ' (popr. vice disket). V pripade modifikace diskety ze skupiny archivu ',13,10
         db        ' musite  tuto  disketu nejdrive vypustit a po modifikaci opet pridat. ',13,10
         db        ' Mezi  operacemi pridani nebo vypusteni neni rozdil, oboji se provadi ',13,10
         db        ' stejnym  zpusobem.  Nejdrive  vlozte  paritni disketu, potom vsechny ',13,10
         db        ' diskety,  ktere  chcete  pridat  ci  vypustit.  Nakonec zvolte povel ',13,10
         db        ' "(Z)apis",  ktery  vygeneruje  novou  paritni disketu (muzete pouzit ',13,10
         db        ' puvodni disketu). Kod za povelem je identifik. kod paritni diskety.  ',13,10
         db        '',13,10
ModTxt0  label     byte

; ------ verifikace diskety

Tst1Txt  dw        Tst1Txt0-Tst1Txt-2
         db        'Ŀ',13,10
         db        '                       TEST citelnosti diskety                     ',13,10
         db        'Ĵ',13,10
         db        ' Vkladejte diskety, ktere chcete overit na citelnost. Pri nalezeni ',13,10
         db        ' chyby cteni se zobrazi chybove hlaseni. Na zaver testu se zobrazi ',13,10
         db        ' tez   kontrolni  soucet  diskety  a  identifikacni  kod  diskety. ',13,10
         db        ' Poznacte  si  tyto  udaje  na  stitek  diskety  pro jeji pozdejsi ',13,10
         db        ' kontrolu  a  identifikaci.  Timto zpusobem je mozne kontrolovat a ',13,10
         db        ' identifikovat tez paritni diskety.                                ',13,10
         db        '',13,10
Tst1Txt0 label     byte

; ------ identifikan kd diskety

IdntTxt  dw        IdntTxt0-IdntTxt-2
         db        'Ŀ',13,10
         db        '                      IDENTIFIKACNI kod diskety                    ',13,10
         db        'Ĵ',13,10
         db        ' Identifikacni  kod  diskety  slouzi k rychle identifikaci diskety ',13,10
         db        ' napr.  pri  vyhledavani diskety, pri kontrole celistvosti skupiny ',13,10
         db        ' disket  nebo  pri pouzivani katalogu disket. Identifikacni kod je ',13,10
         db        ' vytvoren  jako kontrolni soucet stopy 0 na strane 0 diskety. Neni ',13,10
         db        ' potreba  provadet kontrolni soucet cele diskety, pricemz vzajemne ',13,10
         db        ' rozpoznani  disket  je  v  praxi postacujici. Proto se doporucuje ',13,10
         db        ' poznacit si na disketu kontrolni soucet i identifikacni kod.      ',13,10
         db        '                                                                   ',13,10
         db        ' Pozn.: pro zrychleni operace se mechanika mezi disketami nevypina ',13,10
         db        '',13,10
IdntTxt0 label     byte

IdntMnu1 db        3
         db        'D',36
         db        'M',45
         db        'P',58

IdntTxt1 dw        IdntTx10-IdntTxt1-2
         db        13,'Vlozte disketu do '
DiskChr3 db        'A: a zvolte ... (D)alsi, (M)echanika, (P)reruseni'
IdntTx10 label     byte

IdntTxt2 dw        IdntTx20-IdntTxt2-2
IdntTx21 db        '  1 ... '
DiskChr9 db        'A:'
IdntTx22 db        '           '
         db        ' ('
DFormT1  db        '360 KB) ... identifikacni kod='
EDCITxt2 db        'FFFF',13,10
IdntTx20 label     byte

; ------ test celistvosti archivu

TstVTxt  dw        TstVTxt0-TstVTxt-2
         db        'Ŀ',13,10
         db        '              TEST celistvosti skupiny disket archivu             ',13,10
         db        'Ĵ',13,10
         db        ' Pri  testu celistvosti skupiny disket archivu vkladejte postupne ',13,10
         db        ' nejdrive  paritni disketu a potom vsechny ostatni diskety, ktere ',13,10
         db        ' jsou  zabezpeceny touto paritni disketou. Timto testem se overi, ',13,10
         db        ' zda  paritni  disketa  souhlasi  s  prirazenou skupinou archivu. ',13,10
         db        ' Pokud  vlozite  omylem  jinou  disketu  (nebo  dvakrat stejnou), ',13,10
         db        ' vyradite  ji  jejim  opetovnym vlozenim. Po vlozeni vsech disket ',13,10
         db        ' skupiny  archivu  i  s paritni disketou zadejte povel "(K)onec". ',13,10
         db        ' Udaj poctu procent za povelem udava zabezpecenou cast dat.       ',13,10
         db        '',13,10
TstVTxt0 label     byte

TstVMnu2 db        4
         db        'D',27
         db        'K',36
         db        'M',52
         db        'P',65

TstVTxt2 dw        TstVTx20-TstVTxt2-2
         db        13,'Vlozte disketu do '
DiskChrA db        'A: ... (D)alsi, (K)onec ('
DiskUsp  db        '  0%), (M)echanika, (P)reruseni'
TstVTx20 label     byte

TstV3Txt dw        TstV3Tx0-TstV3Txt-2
         db        'Skupina archivu je zabezpecena paritni disketou na 100%.',13,10
TstV3Tx0 label     byte

TstV4Txt dw        TstV4Tx0-TstV4Txt-2
         db        'Paritni disketa NEZABEZPECUJE testovanou skupinou archivu.',13,10
TstV4Tx0 label     byte

; ------ hlen o inicializaci parametr diskety

InitTxt  dw        InitTxt0-InitTxt-2
         db        13,'- inicializuji parametry diskety...',13
InitTxt0 label     byte

; ------ hlen o natn diskety

CtuTxt   dw        CtuTxt0-CtuTxt-2
         db        13,'- ctu disketu  '
DiskChr4 db        'A:'
CtuTxt1  db        '           '
         db        ' ('
DFormT2  db        '360 KB, kod='
CtuTxt4  db        'FFFF) .... VALEC '
CtuTxt2  db        '00, STRANA '
CtuTxt3  db        '0',13
CtuTxt0  label     byte

; ------ hlen o zpisu diskety

ZapTxt   dw        ZapTxt0-ZapTxt-2
         db        13,'- zapisuji  '
DiskChr6 db        'A:'
ZapTxt1  db        '           '
         db        ' ('
DFormT3  db        '360 KB, kod='
ZapTxt4  db        'FFFF) .... VALEC '
ZapTxt2  db        '00, STRANA '
ZapTxt3  db        '0',13
ZapTxt0  label     byte

; ------ zobrazen parametr diskety

NactTxt  dw        NactTxt0-NactTxt-2
NactTxt2 db        '  1 ... '
DiskChr5 db        'A:'
NactTxt1 db        '           '
         db        ' ('
DFormT4  db        '360 KB) .... CRC='
EDCTxt   db        'FFFF, identifikacni kod='
EDCITxt3 db        'FFFF',13,10
NactTxt0 label     byte

ParTxt   db        '[-paritni-]'
NoNamTxt db        'NO NAME    '

;; ------ nekompatibiln formt diskety
;
;FormTxtM db        2
;         db        'O',42
;         db        'P',54
;
;FormTxt  dw        FormTxt0-FormTxt-2
;         db        13
;         db        'CHYBA - nekompatibilni format diskety:  (O)pakovat, (P)rerusit'
;FormTxt0 label     byte

; ------ formt diskety nen shodn

FrmSTxtM db        2
         db        'O',30
         db        'P',52

FrmSTxt  dw        FrmSTxt0-FrmSTxt-2
         db        13
         db        'Format diskety neni shodny: (O)pakovat, (P)rerusit'
FrmSTxt0 label     byte

; ------ chyba ten BOOT sektoru diskety

ErrBTxtM db        3
         db        'O',37
         db        'D',49
         db        'P',57

ErrBTxt  dw        ErrBTxt0-ErrBTxt-2
         db        13
         db        'CHYBA cteni BOOT sektoru diskety:  (O)pakovat, (D)ale, (P)rerusit'
ErrBTxt0 label     byte

; ------ chyba ten

ErrRTxtM db        3
         db        'O',46
         db        'D',58
         db        'P',66

ErrRTxt  dw        ErrRTxt0-ErrRTxt-2
         db        13
ErrRTxt1 db        'CHYBA cteni (VALEC 00/STRANA 0/SEKTOR 00):  (O)pakovat, (D)ale, (P)rerusit'
ErrRTxt0 label     byte

; ------ chyba zpisu - krtk

Er2WMnu  db        4
         db        'O',37
         db        'D',49
         db        'S',57
         db        'P',68

Er2WTxt  dw        Er2WTxt0-Er2WTxt-2
         db        13
Er2WTxt1 db        'CHYBA zapisu (VALEC 00/STRANA 0):  (O)pakovat, (D)ale, (S)ektory, (P)rerusit'
Er2WTxt0 label     byte

; ------ chyba zpisu

ErrWMnu  db        3
         db        'O',47
         db        'D',59
         db        'P',67

ErrWTxt  dw        ErrWTxt0-ErrWTxt-2
         db        13
ErrWTxt1 db        'CHYBA zapisu (VALEC 00/STRANA 0/SEKTOR 00):  (O)pakovat, (D)ale, (P)rerusit'
ErrWTxt0 label     byte

; ------ v mechanice nen disketa

ErrTMnu  db        2
         db        'O',33
         db        'P',45

ErrTTxt  dw        ErrTTxt0-ErrTTxt-2
         db        13
         db        'V mechanice '
DiskChr2 db        'A: neni disketa !  (O)pakovat, (P)rerusit'
ErrTTxt0 label     byte

; ------ disketa chrnna proti zpisu

ErrROMnu db        2
         db        'O',35
         db        'P',47

ErrROTxt dw        ErrROTx0-ErrROTxt-2
         db        13
         db        'Disketa chranena proti zapisu !  (O)pakovat, (P)rerusit'
ErrROTx0 label     byte

; ------ hlen pro pechodn soubor

ErrOTxt  dw        ErrOTxt0-ErrOTxt-2
         db        'CHYBA - nelze vytvorit prechodny soubor !',13,10
ErrOTxt0 label     byte

ErrTRTxt dw        ErrTRTx0-ErrTRTxt-2
         db        'CHYBA cteni z prechodneho souboru !',13,10
ErrTRTx0 label     byte

ErrORTxt dw        ErrTRTx0-ErrTRTxt-2
         db        'CHYBA cteni ze souboru paritni diskety !',13,10
ErrORTx0 label     byte

ErrTWTxt dw        ErrTWTx0-ErrTWTxt-2
         db        'CHYBA zapisu do prechodneho souboru !',13,10
ErrTWTx0 label     byte

ErrTWDTx dw        ErrTWDT0-ErrTWDTx-2
         db        'CHYBA zapisu do prechodneho souboru - nedostatek mista na disku !',13,10
ErrTWDT0 label     byte

ErrOWTxt dw        ErrTWTx0-ErrTWTxt-2
         db        'CHYBA zapisu do souboru paritni diskety !',13,10
ErrOWTx0 label     byte

MazTTxt  dw        80                       ; text pro vymazn dku
         db        13
MazTTxt1 db        78 dup(" "), 13          ; - t jako przdn jmenovka

; ------ tabulky (zachovat sudou adresu !)

         EVEN                               ; zarovnn kvli zsobnku

Old1E    dd        ?                        ; pvodn adresa INT 1Eh

Tab1E    label     byte                     ; tabulka INT 1Eh
         db        ?                        ; 0: krokovn motoru
         db        ?                        ; 1: sputn ptlaku hlavy
MotorOff db        ?                        ; 2: as pro vypnut motoru
SektSize db        ?                        ; 3: velikost sektoru
LastSekt db        ?                        ; 4: posledn sektor na stop
         db        ?                        ; 5: mezisektorov mezera ten
         db        ?                        ; 6: dlka penench dat
         db        ?                        ; 7: mezisektorov mezera formt.
         db        ?                        ; 8: plnc znak formtovn
         db        ?                        ; 9: as pro ustlen hlav
         db        ?                        ; 10: as pro sputn motoru
         db        ?                        ; (11: posledn stopa)
         db        ?                        ; (12: penosov rychlost)
         db        ?                        ;  ... zarovnn na sudou adresu
Tab1E0   label     byte

TrckMap  db        (MAXSEKT+1) AND (NOT 1) dup(?) ; mapa sektor stopy (0=OK)

ErrMap   db        ((MAXTRACK*MAXSEKT*MAXSIDE+16)/8) AND (NOT 1) dup(?) ; mapa vadnch sektor
ErrMap0  label     byte

RepFile  db        128 dup(?)               ; soubor hlen
OutpFile db        128 dup(?)               ; jmno vstupnho souboru
TempFilR db        128 dup(?)               ; pechodn soubor - ten (i zpis)
TempFilW db        128 dup(?)               ; pechodn soubor - zpis

         dw        200h dup(?)              ; zsobnk
Zasobnik label     word                     ; konec zsobnku

Code     ENDS
         END       Start
